searchData={"items":[{"type":"module","title":"exometer","doc":"API and behaviour for metrics instances Predefined templates It is possible to define a set of defaults for exometer. Example: Putting the following in a sys.config file, { exometer , [ { defaults , [ { [ &#39;_&#39; ] , function , [ { module , exometer_function } ] } , { [ &#39;_&#39; ] , counter , [ { module , exometer } ] } , { [ &#39;_&#39; ] , fast_counter , [ { module , exometer } ] } , { [ &#39;_&#39; ] , gauge , [ { module , exometer } ] } , { [ &#39;_&#39; ] , histogram , [ { module , exometer_histogram } ] } , { [ &#39;_&#39; ] , spiral , [ { module , exometer_spiral } ] } ] } ] } will define global defaults for the given metric types. The format is {NamePattern, Type, Options} The options can be overridden by options given in the new() command. NamePattern is similar to that used in find_entries/1 . For more information, see exometer_admin:set_default/3 .","ref":"exometer.html"},{"type":"function","title":"exometer.aggregate/2","doc":"Aggregate datapoints of matching entries. This function selects metric entries based on the given match spec, and summarizes the given datapoint values. Note that the match body of the match spec will be overwritten, to produce only the value for each entry matching the head and guard pattern(s). The function can for example be used inside a function metric: 1 &gt; exometer : start ( ) . ok 2 &gt; exometer : new ( [ g , 1 ] , gauge , [ ] ) . ok 3 &gt; exometer : new ( [ g , 2 ] , gauge , [ ] ) . ok 4 &gt; exometer : new ( [ g , 3 ] , gauge , [ ] ) . ok 5 &gt; [ exometer : update ( N , V ) || { N , V } &lt;- [ { [ g , 1 ] , 3 } , { [ g , 2 ] , 4 } , { [ g , 3 ] , 5 } ] ] . [ ok , ok , ok ] 6 &gt; exometer : new ( [ g ] , { function , exometer , aggregate , [ [ { { [ g , &#39;_&#39; ] , &#39;_&#39; , &#39;_&#39; } , [ ] , [ true ] } ] , [ value ] ] , value , [ value ] } , [ ] ) . ok 7 &gt; exometer : get_value ( [ g ] , [ value ] ) . { ok , [ { value , 12 } ] }","ref":"exometer.html#aggregate/2"},{"type":"function","title":"exometer.create_entry/1","doc":null,"ref":"exometer.html#create_entry/1"},{"type":"function","title":"exometer.delete/1","doc":"Delete the metric","ref":"exometer.html#delete/1"},{"type":"function","title":"exometer.ensure/3","doc":"Ensure that metric exists and is of given type. This function is similar to re-register, but doesn't actually re-register a metric if it already exists. If a matching entry is found, a check is performed to verify that it is of the correct type. If it isn't, an error tuple is returned.","ref":"exometer.html#ensure/3"},{"type":"function","title":"exometer.find_entries/1","doc":"Find metrics based on a name prefix pattern. This function will find and return metrics whose name matches the given prefix. For example [kvdb, kvdb_conf, Table] would match any metrics tied to the given table in the kvdb_conf database. It is possible to insert wildcards: [kvdb, kvdb_conf, '_', write] would match write -related metrics in all tables of the kvdb_conf database. The format of the returned metrics is [{Name, Type, Status}] .","ref":"exometer.html#find_entries/1"},{"type":"function","title":"exometer.get_value/1","doc":"Fetch the current value of the metric. For a built-in counter, the value returned is the sum of all counter instances (one per scheduler). For plugin metrics, the callback module is responsible for providing the value. If the metric has a specified (non-zero) cache lifetime, and a value resides in the cache, the cached value will be returned.","ref":"exometer.html#get_value/1"},{"type":"function","title":"exometer.get_value/2","doc":null,"ref":"exometer.html#get_value/2"},{"type":"function","title":"exometer.get_values/1","doc":null,"ref":"exometer.html#get_values/1"},{"type":"function","title":"exometer.global_status/1","doc":null,"ref":"exometer.html#global_status/1"},{"type":"function","title":"exometer.info/1","doc":"Returns a list of info items for Metric, see info/2 .","ref":"exometer.html#info/1"},{"type":"function","title":"exometer.info/2","doc":"Retrieves information about a metric. Supported info items: * name - The name of the metric * type - The type of the metric * module - The callback module used * value - The result of get_value(Name) * cache - The cache lifetime * status - Operational status: enabled or disabled * timestamp - When the metric was last reset/initiated * datapoints - Data points available for retrieval with get_value() * options - Options passed to the metric at creation (or via setopts()) * ref - Instance-specific reference; usually a pid (probe) or undefined","ref":"exometer.html#info/2"},{"type":"function","title":"exometer.new/2","doc":"Equivalent to new(Name, Type, []) .","ref":"exometer.html#new/2"},{"type":"function","title":"exometer.new/3","doc":"Create a new metrics entry. Name must be a list of terms (e.g. atoms). Type must be either one of the built-in types, or match a predefined template. Options will be passed to the entry, but the framework will recognize the following options: * {cache, Lifetime} - Cache the results of get_value/1 for the given number of milliseconds. Subsequent calls to get_value/1 will get the cached value, if found. Default is 0 , which means no caching will be performed. * {status, enabled | disabled} - Default is enabled . If the metric is disabled , calls to get_value/1 will return {ok, disabled} , and calls to update/2 and sample/1 will return ok but will do nothing. * {snmp, [{DataPoint, ReportInterval}]} - defines a link to SNMP reporting, where the given data points are sampled at the given intervals, converted to SNMP PDUs and transmitted via the exometer_report_snmp reporter. * {snmp_syntax, [{DataPoint | {default}, SYNTAX}]} - specifies a custom SNMP type for a given data point. SYNTAX needs to be a binary or a string, and corresponds to the SYNTAX definition in the generated SNMP MIB. * {aliases, [{DataPoint, Alias}]} - maps aliases to datapoints. See exometer_alias:new/2 . * {'--', Keys} removes option keys from the applied template. This can be used to clean up the options list when overriding the defaults for a given namespace (if the default definition contains options that are not applicable, or would even cause problems with the current entry.) For example, the default value for an exometer counter is &quot;Counter32&quot; , which expands to SYNTAX Counter32 in the corresponding MIB object definition. If a 64-bit counter (not supported by SNMPv1) is desired instead, the option {snmp_syntax, [{value, &quot;Counter64&quot;}]} can be added to the counter entry (note that value in this case is the name of the data point representing the counter value).","ref":"exometer.html#new/3"},{"type":"function","title":"exometer.propose/3","doc":"Propose a new exometer entry (no entry actually created). This function analyzes a proposed entry definition, applying templates and processing options in the same way as new/3 , but not actually creating the entry. The return value, if successful, corresponds to exometer_info:pp(Entry) .","ref":"exometer.html#propose/3"},{"type":"function","title":"exometer.re_register/3","doc":"Create a new metrics entry, overwrite any old entry. This function behaves as new/3 , but will not fail if an entry with the same name already exists. Instead, the old entry will be replaced by the new.","ref":"exometer.html#re_register/3"},{"type":"function","title":"exometer.register_application/0","doc":"Equivalent to register_application(current_application()) .","ref":"exometer.html#register_application/0"},{"type":"function","title":"exometer.register_application/1","doc":"Registers statically defined entries with exometer. This function can be used e.g. as a start phase hook or during upgrade. It will check for the environment variables exometer_defaults and exometer_predefined in Application , and apply them as if it had when exometer was first started. If the function is called again, the settings are re-applied. This can be used e.g. during upgrade, in order to change statically defined settings. If exometer is not running, the function does nothing.","ref":"exometer.html#register_application/1"},{"type":"function","title":"exometer.repair/1","doc":"Delete and re-create an entry. This function can be tried if a metric (e.g. a complex probe) has become 'stuck' or otherwise isn't functioning properly. It fetches the stored meta-data and then deletes and re-creates the metric.","ref":"exometer.html#repair/1"},{"type":"function","title":"exometer.reset/1","doc":"Reset the metric. For a built-in counter, the value of the counter is set to zero. For other types of metric, the callback module will define exactly what happens when a reset() is requested. A timestamp ( os:timestamp() ) is saved in the exometer entry, which can be recalled using info/2 , and will indicate the time that has passed since the metric was last reset.","ref":"exometer.html#reset/1"},{"type":"function","title":"exometer.sample/1","doc":"Tells the metric (mainly probes) to take a sample. Probes often take care of data sampling using a configured sample interval. This function provides a way to explicitly tell a probe to take a sample. The operation is asynchronous. For other metrics, the operation likely has no effect, and will return ok .","ref":"exometer.html#sample/1"},{"type":"function","title":"exometer.select/1","doc":"Perform an ets:select() on the set of metrics. This function operates on a virtual structure representing the metrics, but otherwise works as a normal select() . The representation of the metrics is {Name, Type, Status} .","ref":"exometer.html#select/1"},{"type":"function","title":"exometer.select/2","doc":"Perform an ets:select() with a Limit on the set of metrics. This function is equivalent to select/1 , but also takes a limit. After Limit number of matches, the function returns the matches and a continuation, which can be passed to select_cont/1 .","ref":"exometer.html#select/2"},{"type":"function","title":"exometer.select_cont/1","doc":"Equivalent to ets:select(Cont) .","ref":"exometer.html#select_cont/1"},{"type":"function","title":"exometer.select_count/1","doc":"Corresponds to ets:select_count/1 .","ref":"exometer.html#select_count/1"},{"type":"function","title":"exometer.setopts/2","doc":"Change options for the metric. Valid options are whatever the metric type supports, plus: * {cache, Lifetime} - The cache lifetime (0 for no caching). * {status, enabled | disabled} - the operational status of the metric. Note that if the metric is disabled, setopts/2 will fail unless the options list contains {status, enabled} , which will enable the metric and cause other options to be processed.","ref":"exometer.html#setopts/2"},{"type":"function","title":"exometer.start/0","doc":"Start exometer and dependent apps (for testing).","ref":"exometer.html#start/0"},{"type":"function","title":"exometer.stop/0","doc":"Stop exometer and dependent apps (for testing).","ref":"exometer.html#stop/0"},{"type":"function","title":"exometer.update/2","doc":"Update the given metric with Value . The exact semantics of an update will vary depending on metric type. For exometer's built-in counters, the counter instance on the current scheduler will be incremented. For a plugin metric (e.g. a probe), the corresponding callback module will be called. For a disabled metric, ok will be returned without any other action being taken.","ref":"exometer.html#update/2"},{"type":"function","title":"exometer.update_or_create/2","doc":"Update existing metric, or create+update according to template. If the metric exists, it is updated (see update/2 ). If it doesn't, exometer searches for a template matching Name , picks the best match and creates a new entry based on the template (see exometer_admin:set_default/3 ). Note that fully wild-carded templates (i.e. ['_'] ) are ignored.","ref":"exometer.html#update_or_create/2"},{"type":"function","title":"exometer.update_or_create/4","doc":null,"ref":"exometer.html#update_or_create/4"},{"type":"type","title":"exometer.behaviour/0","doc":null,"ref":"exometer.html#t:behaviour/0"},{"type":"type","title":"exometer.datapoint/0","doc":null,"ref":"exometer.html#t:datapoint/0"},{"type":"type","title":"exometer.entry/0","doc":null,"ref":"exometer.html#t:entry/0"},{"type":"type","title":"exometer.error/0","doc":null,"ref":"exometer.html#t:error/0"},{"type":"type","title":"exometer.info/0","doc":null,"ref":"exometer.html#t:info/0"},{"type":"type","title":"exometer.name/0","doc":null,"ref":"exometer.html#t:name/0"},{"type":"type","title":"exometer.options/0","doc":null,"ref":"exometer.html#t:options/0"},{"type":"type","title":"exometer.status/0","doc":null,"ref":"exometer.html#t:status/0"},{"type":"type","title":"exometer.type/0","doc":null,"ref":"exometer.html#t:type/0"},{"type":"type","title":"exometer.value/0","doc":null,"ref":"exometer.html#t:value/0"},{"type":"module","title":"exometer_admin","doc":null,"ref":"exometer_admin.html"},{"type":"function","title":"exometer_admin.auto_create_entry/1","doc":null,"ref":"exometer_admin.html#auto_create_entry/1"},{"type":"function","title":"exometer_admin.code_change/3","doc":null,"ref":"exometer_admin.html#code_change/3"},{"type":"function","title":"exometer_admin.delete_entry/1","doc":null,"ref":"exometer_admin.html#delete_entry/1"},{"type":"function","title":"exometer_admin.demonitor/1","doc":null,"ref":"exometer_admin.html#demonitor/1"},{"type":"function","title":"exometer_admin.ensure/3","doc":null,"ref":"exometer_admin.html#ensure/3"},{"type":"function","title":"exometer_admin.find_auto_template/1","doc":"Convenience function for testing which template will apply to Name . See set_default/2 and exometer:update_or_create/2 .","ref":"exometer_admin.html#find_auto_template/1"},{"type":"function","title":"exometer_admin.handle_call/3","doc":null,"ref":"exometer_admin.html#handle_call/3"},{"type":"function","title":"exometer_admin.handle_cast/2","doc":null,"ref":"exometer_admin.html#handle_cast/2"},{"type":"function","title":"exometer_admin.handle_info/2","doc":null,"ref":"exometer_admin.html#handle_info/2"},{"type":"function","title":"exometer_admin.init/1","doc":null,"ref":"exometer_admin.html#init/1"},{"type":"function","title":"exometer_admin.load_defaults/0","doc":null,"ref":"exometer_admin.html#load_defaults/0"},{"type":"function","title":"exometer_admin.load_predefined/0","doc":null,"ref":"exometer_admin.html#load_predefined/0"},{"type":"function","title":"exometer_admin.make_patterns/2","doc":null,"ref":"exometer_admin.html#make_patterns/2"},{"type":"function","title":"exometer_admin.monitor/2","doc":null,"ref":"exometer_admin.html#monitor/2"},{"type":"function","title":"exometer_admin.monitor/3","doc":null,"ref":"exometer_admin.html#monitor/3"},{"type":"function","title":"exometer_admin.new_entry/3","doc":null,"ref":"exometer_admin.html#new_entry/3"},{"type":"function","title":"exometer_admin.normalize_name/1","doc":null,"ref":"exometer_admin.html#normalize_name/1"},{"type":"function","title":"exometer_admin.prefixes/1","doc":null,"ref":"exometer_admin.html#prefixes/1"},{"type":"function","title":"exometer_admin.preset_defaults/0","doc":null,"ref":"exometer_admin.html#preset_defaults/0"},{"type":"function","title":"exometer_admin.propose/3","doc":null,"ref":"exometer_admin.html#propose/3"},{"type":"function","title":"exometer_admin.re_register_entry/3","doc":null,"ref":"exometer_admin.html#re_register_entry/3"},{"type":"function","title":"exometer_admin.register_application/1","doc":null,"ref":"exometer_admin.html#register_application/1"},{"type":"function","title":"exometer_admin.repair_entry/1","doc":null,"ref":"exometer_admin.html#repair_entry/1"},{"type":"function","title":"exometer_admin.set_default/3","doc":"Sets a default definition for a metric type, possibly using wildcards. Names are lists of atoms, where '_' is a wildcard. For example, [a, b, c, '_'] matches all children and grandchildren of [a, b, c] , whereas [a, b, c, d] specifies a single name. The longest match will be selected, unless an exact match is found. The definition can be given either as an #exometer_entry{} record, or a list of {Key, Value} tuples, where each Key matches an attribute of the #exometer_entry{} record.","ref":"exometer_admin.html#set_default/3"},{"type":"function","title":"exometer_admin.start_link/0","doc":null,"ref":"exometer_admin.html#start_link/0"},{"type":"function","title":"exometer_admin.terminate/2","doc":null,"ref":"exometer_admin.html#terminate/2"},{"type":"module","title":"exometer_alias","doc":"API and behaviour for metrics instances This module implements an alias registry for exometer metrics. An alias can be either an atom or a binary, and maps to an entry+datapoint pair. The registry is an ordered set with binary keys, enabling straight lookup, prefix match/fold and regexp fold. The purpose of the registry is to support mapping of 'legacy names' to exometer metrics, where the legacy names don't conform to the exometer naming standard.","ref":"exometer_alias.html"},{"type":"function","title":"exometer_alias.check_map/1","doc":null,"ref":"exometer_alias.html#check_map/1"},{"type":"function","title":"exometer_alias.delete/1","doc":"Delete an alias, if it exists in the registry. This function will delete an alias if it exists in the registry. It will return ok signaling that after completion, the alias is no longer in the registry.","ref":"exometer_alias.html#delete/1"},{"type":"function","title":"exometer_alias.get_value/1","doc":"Resolve the given alias and return corresponding metric and value. The function returns {ok, Value} or {error, not_found} depending on whether there is a 'live' mapping (i.e. the entry refered to by the alias also exists.)","ref":"exometer_alias.html#get_value/1"},{"type":"function","title":"exometer_alias.load/1","doc":"Load a list of mappings between entry+datapoint pairs and aliases. This operation will overwrite any aliases with the same name that already exist. The argument is a fun (zero arity) that returns a list of {EntryName, [{DataPoint, Alias}]} tuples.","ref":"exometer_alias.html#load/1"},{"type":"function","title":"exometer_alias.new/3","doc":"Create a new alias. This function maps an alias to an entry name and datapoint. Each alias maps to exactly one entry+datapoint pair. The entry does not need to exist when the alias is registered. The function raises an exception if the arguments are of the wrong type, and returns {error, exists} if the alias has already been registered.","ref":"exometer_alias.html#new/3"},{"type":"function","title":"exometer_alias.prefix_foldl/3","doc":"Fold (ascending order) over the aliases matching Prefix . The fold function is called with F(Alias, Entry, Datapoint) . Note that the referenced entry may not yet be created.","ref":"exometer_alias.html#prefix_foldl/3"},{"type":"function","title":"exometer_alias.prefix_foldr/3","doc":"Fold (descending order) over the aliases matching Prefix . The fold function is called with F(Alias, Entry, Datapoint) . Note that the referenced entry may not yet be created.","ref":"exometer_alias.html#prefix_foldr/3"},{"type":"function","title":"exometer_alias.prefix_match/1","doc":"List all aliases matching the given prefix. Even if the alias is an atom, prefix matching will be performed. Note that the referenced entries may not yet be created.","ref":"exometer_alias.html#prefix_match/1"},{"type":"function","title":"exometer_alias.regexp_foldl/3","doc":"Fold (ascending order) over the aliases matching Regexp . The fold function is called with F(Alias, Entry, Datapoint) . Note that the referenced entry may not yet be created. In order to avoid scanning the whole registry, a prefix is extracted from the regular expression. For a non-empty prefix, make sure to anchor the regular expression to the beginning of the name (e.g. &quot;^my_stats.*&quot; ).","ref":"exometer_alias.html#regexp_foldl/3"},{"type":"function","title":"exometer_alias.regexp_foldr/3","doc":"Fold (descending order) over the aliases matching Regexp . The fold function is called with F(Alias, Entry, Datapoint) . Note that the referenced entry may not yet be created. In order to avoid scanning the whole registry, a prefix is extracted from the regular expression. For a non-empty prefix, make sure to anchor the regular expression to the beginning of the name (e.g. &quot;^my_stats.*&quot; ).","ref":"exometer_alias.html#regexp_foldr/3"},{"type":"function","title":"exometer_alias.resolve/1","doc":"Look up an alias in the registry and return corresponding mapping. This function returns {EntryName, Datapoint} corresponding to the given alias, or error if no corresponding mapping exists.","ref":"exometer_alias.html#resolve/1"},{"type":"function","title":"exometer_alias.reverse_map/2","doc":"List all aliases mapped to the given entry+datapoint pair(s). Match spec-style wildcards can be used for Name and/or Datapoint .","ref":"exometer_alias.html#reverse_map/2"},{"type":"function","title":"exometer_alias.start_link/0","doc":null,"ref":"exometer_alias.html#start_link/0"},{"type":"function","title":"exometer_alias.unload/1","doc":"Unload a list of mappings. A mapping will only be deleted if the given alias+entry+datapoint matches what is in the registry. The argument is of the same type as for load/1 .","ref":"exometer_alias.html#unload/1"},{"type":"function","title":"exometer_alias.update/2","doc":"Resolves the given alias and updates the corresponding entry (if any). This function can be seen as a wrapper to exometer:update/2 . Although the alias maps to a given datapoint, the entry itself is updated, so any alias mapping to the same entry can be used with the same result.","ref":"exometer_alias.html#update/2"},{"type":"type","title":"exometer_alias.acc/0","doc":null,"ref":"exometer_alias.html#t:acc/0"},{"type":"type","title":"exometer_alias.alias/0","doc":null,"ref":"exometer_alias.html#t:alias/0"},{"type":"type","title":"exometer_alias.dp/0","doc":null,"ref":"exometer_alias.html#t:dp/0"},{"type":"type","title":"exometer_alias.fold_fun/0","doc":null,"ref":"exometer_alias.html#t:fold_fun/0"},{"type":"type","title":"exometer_alias.mp/0","doc":null,"ref":"exometer_alias.html#t:mp/0"},{"type":"type","title":"exometer_alias.name/0","doc":null,"ref":"exometer_alias.html#t:name/0"},{"type":"type","title":"exometer_alias.reason/0","doc":null,"ref":"exometer_alias.html#t:reason/0"},{"type":"type","title":"exometer_alias.regexp/0","doc":null,"ref":"exometer_alias.html#t:regexp/0"},{"type":"type","title":"exometer_alias.stat_map/0","doc":null,"ref":"exometer_alias.html#t:stat_map/0"},{"type":"module","title":"exometer_cache","doc":null,"ref":"exometer_cache.html"},{"type":"function","title":"exometer_cache.code_change/3","doc":null,"ref":"exometer_cache.html#code_change/3"},{"type":"function","title":"exometer_cache.delete/2","doc":null,"ref":"exometer_cache.html#delete/2"},{"type":"function","title":"exometer_cache.delete_name/1","doc":null,"ref":"exometer_cache.html#delete_name/1"},{"type":"function","title":"exometer_cache.handle_call/3","doc":null,"ref":"exometer_cache.html#handle_call/3"},{"type":"function","title":"exometer_cache.handle_cast/2","doc":null,"ref":"exometer_cache.html#handle_cast/2"},{"type":"function","title":"exometer_cache.handle_info/2","doc":null,"ref":"exometer_cache.html#handle_info/2"},{"type":"function","title":"exometer_cache.init/1","doc":null,"ref":"exometer_cache.html#init/1"},{"type":"function","title":"exometer_cache.read/2","doc":null,"ref":"exometer_cache.html#read/2"},{"type":"function","title":"exometer_cache.start_link/0","doc":null,"ref":"exometer_cache.html#start_link/0"},{"type":"function","title":"exometer_cache.terminate/2","doc":null,"ref":"exometer_cache.html#terminate/2"},{"type":"function","title":"exometer_cache.write/3","doc":null,"ref":"exometer_cache.html#write/3"},{"type":"function","title":"exometer_cache.write/4","doc":null,"ref":"exometer_cache.html#write/4"},{"type":"module","title":"exometer_cpu","doc":null,"ref":"exometer_cpu.html"},{"type":"function","title":"exometer_cpu.behaviour/0","doc":null,"ref":"exometer_cpu.html#behaviour/0"},{"type":"function","title":"exometer_cpu.probe_code_change/3","doc":null,"ref":"exometer_cpu.html#probe_code_change/3"},{"type":"function","title":"exometer_cpu.probe_get_datapoints/1","doc":null,"ref":"exometer_cpu.html#probe_get_datapoints/1"},{"type":"function","title":"exometer_cpu.probe_get_value/2","doc":null,"ref":"exometer_cpu.html#probe_get_value/2"},{"type":"function","title":"exometer_cpu.probe_handle_msg/2","doc":null,"ref":"exometer_cpu.html#probe_handle_msg/2"},{"type":"function","title":"exometer_cpu.probe_init/3","doc":null,"ref":"exometer_cpu.html#probe_init/3"},{"type":"function","title":"exometer_cpu.probe_reset/1","doc":null,"ref":"exometer_cpu.html#probe_reset/1"},{"type":"function","title":"exometer_cpu.probe_sample/1","doc":null,"ref":"exometer_cpu.html#probe_sample/1"},{"type":"function","title":"exometer_cpu.probe_setopts/3","doc":null,"ref":"exometer_cpu.html#probe_setopts/3"},{"type":"function","title":"exometer_cpu.probe_terminate/1","doc":null,"ref":"exometer_cpu.html#probe_terminate/1"},{"type":"function","title":"exometer_cpu.probe_update/2","doc":null,"ref":"exometer_cpu.html#probe_update/2"},{"type":"module","title":"exometer_duration","doc":null,"ref":"exometer_duration.html"},{"type":"function","title":"exometer_duration.behaviour/0","doc":null,"ref":"exometer_duration.html#behaviour/0"},{"type":"function","title":"exometer_duration.delete/3","doc":null,"ref":"exometer_duration.html#delete/3"},{"type":"function","title":"exometer_duration.get_datapoints/3","doc":null,"ref":"exometer_duration.html#get_datapoints/3"},{"type":"function","title":"exometer_duration.get_value/3","doc":null,"ref":"exometer_duration.html#get_value/3"},{"type":"function","title":"exometer_duration.get_value/4","doc":null,"ref":"exometer_duration.html#get_value/4"},{"type":"function","title":"exometer_duration.new/3","doc":null,"ref":"exometer_duration.html#new/3"},{"type":"function","title":"exometer_duration.probe_code_change/3","doc":null,"ref":"exometer_duration.html#probe_code_change/3"},{"type":"function","title":"exometer_duration.probe_get_datapoints/1","doc":null,"ref":"exometer_duration.html#probe_get_datapoints/1"},{"type":"function","title":"exometer_duration.probe_get_value/2","doc":null,"ref":"exometer_duration.html#probe_get_value/2"},{"type":"function","title":"exometer_duration.probe_handle_msg/2","doc":null,"ref":"exometer_duration.html#probe_handle_msg/2"},{"type":"function","title":"exometer_duration.probe_init/3","doc":null,"ref":"exometer_duration.html#probe_init/3"},{"type":"function","title":"exometer_duration.probe_reset/1","doc":null,"ref":"exometer_duration.html#probe_reset/1"},{"type":"function","title":"exometer_duration.probe_sample/1","doc":null,"ref":"exometer_duration.html#probe_sample/1"},{"type":"function","title":"exometer_duration.probe_setopts/3","doc":null,"ref":"exometer_duration.html#probe_setopts/3"},{"type":"function","title":"exometer_duration.probe_terminate/1","doc":null,"ref":"exometer_duration.html#probe_terminate/1"},{"type":"function","title":"exometer_duration.probe_update/2","doc":null,"ref":"exometer_duration.html#probe_update/2"},{"type":"function","title":"exometer_duration.reset/3","doc":null,"ref":"exometer_duration.html#reset/3"},{"type":"function","title":"exometer_duration.sample/3","doc":null,"ref":"exometer_duration.html#sample/3"},{"type":"function","title":"exometer_duration.setopts/3","doc":null,"ref":"exometer_duration.html#setopts/3"},{"type":"function","title":"exometer_duration.update/4","doc":null,"ref":"exometer_duration.html#update/4"},{"type":"behaviour","title":"exometer_entry","doc":"Creating custom exometer entries An exometer_entry behavior implementation can be created when custom processing of various metrics is needed. A custom exometer entry is invoked by mapping a type to the module name of the custom exometer entry module. All metrics created with the given type will trigger the invocation of the new entry module. See Configuring type - entry maps for details on how to setup such maps. The life cycle of a an exometer entry consists of the following steps. + Metrics Creation new/3 is invoked by exometer to signal that a new metrics should be created. The name of the new metric will be provided as a list of atoms. + Update Data Values will be sent to the entry through the update/4 function. The custom entry should store this value for the given metric and break it down into data points that can be reported for the metric. + Retrieve Value get_value/4 will be invoked by exometer to retrieve specific data points from a given metric. See individual functions for details on the in the exometer_entry behavior. behaviour/0 The behaviour() function for an entry implementation should return the atom entry . This function will be involved by the exometer system in order to determine if a callback is an entry or a probe. new/3 The new() function is invoked as follows: new ( Name , Type , Options ) The custom entry should create the necessary state for the new metric and store it for furure access through update() and get_value() calls. + Name Specifies the name of the metric to be created as a list of atoms. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). It can be used if several different types are mapped to the same entry module. + Options Specifies an option list that contains additional setup directives to the entry. The actual options to support are implementation dependent. The new() function should return {ok, Ref} where Ref is a tuple that will be provided as a reference argument to other calls made into the module. Any other return formats will cancel the creation of the new metric. delete/3 The delete() function is invoked as follows: delete ( Name , Type , Ref ) The custom entry should free all resources associated with the given name. + Name Specifies the name of the metric to be deleted as a list of atoms. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). + Ref Will contain the same tuple returned as Ref by the module's new() function. The delete() function shall return ok . get_value/4 The get_value() function is invoked as follows: get_value ( Name , Type , Ref , DataPoints ) The custom entry should retrieve the metric with the given name and return the values of the specified data points. Data points can be expected to be one or more of those returned by the entry's get_datapoints() function. + Name Specifies the name of the metric to update with a value. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). + Ref Will contain the same tuple returned as Ref by the module's new() function. + DataPoints Will contain a list of data points, each picked from the list returned by the module's get_datapoints() function. The get_value() function should calculate the values of the given data points based on previous calls to update() and return them to the caller. The return format shall be: { ok , [ { DataPoint , Value } , . . . ] } Each { DataPoint, Value } tuple shall contain the name and value of one of the data points provided as arguments to get_value() . If a data point is not valid (i.e. not in the list returned by get_datapoints() ), the returned tuple should be { DataPoint, undefined } . update/4 The update() function is invoked as follows: update ( Name , Value , Type , Ref ) + Name Specifies the name of the metric to update. + Value Specifies the new value to integrate into the given metric. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). + Ref Will contain the same tuple returned as Ref by the module's new() function. The update() function should update the data points for the metric with the given name in preparation for future calls to get_value() . The return format shall be ok . reset/3 The reset() function is invoked as follows: reset ( Name , Type , Ref ) + Name Specifies the name of the metric to reset. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). + Ref Will contain the same tuple returned as Ref by the module's new() function. The reset() function should revert the metric with the given name to its original state. A counter, for example, should be reset to 0 while histograms should be emptied. The return format shall be ok . sample/3 The sample() function is invoked as follows: sample ( Name , Type , Ref ) + Name Specifies the name of the metric to run the sample. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). + Ref Will contain the same tuple returned as Ref by the module's new() function. This function is only used by probes, where it is periodically called to sample a local sub system such as /proc or netlink in order to update its data points. Any exometer entry-based implementation should do nothing and return ok . get_datapoints/3 The get_datapoints() function is invoked as follows: get_datapoints ( Name , Type , Ref ) + Name Specifies the name of the metric to return available datapoints for. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). + Ref Will contain the same tuple returned as Ref by the module's new() function. This function should return a list of all data points supported by the exometer entry implementation. The returned data points shall be supported by the module's get_value() function. setopts/3 The setopts() function is invoked as follows: setopts ( Entry , Options , Type , Ref ) + Entry The (opaque) exometer entry record. See exometer_info for information on how to inspect the data structure. + Options Specifies an option list that contains additional setup directives to the entry. The actual options to support are implementation dependent. + Type Specifies the type provided to the exometer:new() call (before it was translated by the type - exometer entry map). + Ref Will contain the same tuple returned as Ref by the module's new() function. This function should modify the behavior of the given metric by the options provided in the Options property list. The function should return either ok or {error, Reason} , where Reason contins a descriptive reason for a failure to set one or more options.","ref":"exometer_entry.html"},{"type":"callback","title":"exometer_entry.behaviour/0","doc":null,"ref":"exometer_entry.html#c:behaviour/0"},{"type":"callback","title":"exometer_entry.delete/3","doc":null,"ref":"exometer_entry.html#c:delete/3"},{"type":"callback","title":"exometer_entry.get_datapoints/3","doc":null,"ref":"exometer_entry.html#c:get_datapoints/3"},{"type":"callback","title":"exometer_entry.get_value/4","doc":null,"ref":"exometer_entry.html#c:get_value/4"},{"type":"callback","title":"exometer_entry.new/3","doc":null,"ref":"exometer_entry.html#c:new/3"},{"type":"callback","title":"exometer_entry.reset/3","doc":null,"ref":"exometer_entry.html#c:reset/3"},{"type":"callback","title":"exometer_entry.sample/3","doc":null,"ref":"exometer_entry.html#c:sample/3"},{"type":"callback","title":"exometer_entry.setopts/3","doc":null,"ref":"exometer_entry.html#c:setopts/3"},{"type":"callback","title":"exometer_entry.update/4","doc":null,"ref":"exometer_entry.html#c:update/4"},{"type":"type","title":"exometer_entry.datapoint/0","doc":null,"ref":"exometer_entry.html#t:datapoint/0"},{"type":"type","title":"exometer_entry.datapoints/0","doc":null,"ref":"exometer_entry.html#t:datapoints/0"},{"type":"type","title":"exometer_entry.error/0","doc":null,"ref":"exometer_entry.html#t:error/0"},{"type":"type","title":"exometer_entry.name/0","doc":null,"ref":"exometer_entry.html#t:name/0"},{"type":"type","title":"exometer_entry.options/0","doc":null,"ref":"exometer_entry.html#t:options/0"},{"type":"type","title":"exometer_entry.ref/0","doc":null,"ref":"exometer_entry.html#t:ref/0"},{"type":"type","title":"exometer_entry.type/0","doc":null,"ref":"exometer_entry.html#t:type/0"},{"type":"type","title":"exometer_entry.value/0","doc":null,"ref":"exometer_entry.html#t:value/0"},{"type":"module","title":"exometer_function","doc":null,"ref":"exometer_function.html"},{"type":"function","title":"exometer_function.behaviour/0","doc":null,"ref":"exometer_function.html#behaviour/0"},{"type":"function","title":"exometer_function.delete/3","doc":null,"ref":"exometer_function.html#delete/3"},{"type":"function","title":"exometer_function.empty/0","doc":null,"ref":"exometer_function.html#empty/0"},{"type":"function","title":"exometer_function.eval_exprs/2","doc":"Evaluate a list of abstract expressions. This function is reminiscent of erl_eval:exprs/2 , but with a slightly different expression grammar. Most prominently, forms have no line numbers, and a few aliases for more compact representation. Otherwise, the forms can be seen as mostly a subset of the Erlang abstract forms. The list of bindings correspods exactly to the bindings in erl_eval . * Integers: {integer, I} , {i, I} , or simply just the integer * Atoms: {atom, A} , {a, A} , or simply just the atom (note that some atoms are special). * Lists: {cons, H, T} , nil , or {l, [...]} * Tuples: {tuple, [Elem]} , or {t, [Elem]} * Variables: {var, V} , or {v, V} * Matches: {match, Pattern, Expr} , or {m, Pattern, Expr} * Function calls: {call, {M, F}, Args} , or {call, F, Args} * Folds: {fold, IterVar, AccVar, [IterExpr], Acc0Expr, ListExpr} * Operators: {op, Op, ExprA, ExprB} * Unary operators: {op, '-' | 'not', Expr} * Case exprs: {'case', [Expr], [{Pat, Gs, Body}]} * Generic Erlang: {erl, [ErlAbstractExpr]} The currently supported &quot;built-in functions&quot; are length/1 , size/1 , byte_size/1 and bit_size/1 . The operators supported are all the Erlang binary operators (as in: '+', '-', '==', '=/=', etc.) When evaluating guards in a case clause, any expression is legal. The guard must return true to succeed. Note that the abstract form of a guard sequence is [ [G11,...], [G21,...], ...], where each sublist represents an 'and' sequence, i.e. all guards in the sublist must succeed. The relationship between sublists is 'or'. This is the same as in Erlang.","ref":"exometer_function.html#eval_exprs/2"},{"type":"function","title":"exometer_function.get_datapoints/3","doc":null,"ref":"exometer_function.html#get_datapoints/3"},{"type":"function","title":"exometer_function.get_value/4","doc":null,"ref":"exometer_function.html#get_value/4"},{"type":"function","title":"exometer_function.new/3","doc":"Callback for creating an exometer function entry. Function entries are created as exometer : new ( Name , { function , . . . } , Opts ) which is syntactic sugar for exometer : new ( Name , function , [ { arg , { function , . . . } } | Opts ] ) {function,...} can be {function, Mod, Fun} , in which case where get_value(Name, DataPoints) will result in a call to Mod:Fun(DataPoints) . Invoking get_value(Name) (with no datapoints), will call Mod:Fun(default), which must return a default list of data point values. `{function,...} can also be setup as {function, Mod,Fun,ArgSpec,Type,DataPoints} in order to invoke a limited interpreter. The ArgSpec is evaluated as follows: [] means to call with no arguments, i.e. M:F() A list of patterns will be used as arguments, substituting the following patterns: '$dp' is replaced by the current data point '$datapoints' is replaced by the requested list of data points. Note that '$dp' and '$datapoints' are mutually exclusive {'$call', M, F, Args0} will be replaced by the result of calling apply(M, F, Args) where Args is the list of arguments after performing substitution on Args0 . {'$value', Term} uses Term without substitution. The return value of the above call will be processed according to Type : If Type==value , the return value is returned as-is If Type==histogram , the return value is a list of integers, which will be compiled into a histogram (see exometer_histogram ). If Type==proplist , the current data point or list of data points will be picked out of the returned proplist. If Type==tagged , the return value is assumed to be either {ok, Value} or {DataPointName, Value} . If Type==match , DataPoints is used as a pattern to match against, where the names of data points are used where the values are expected to be, and '_' is used for values to ignore. The pattern can be any combination of tuples and lists of datapoints or '_' . If Type==eval , DataPoints is expected to be {Exprs, DPs} , and eval_exprs/2 will be used to evaluate Exprs . The return value from the function call will be bound to Value , and the list of data points will be bound to DPs . The evaluation must return a list of {DataPointName, Value} tuples. An alternative version of arg is {arg, {eval, Exprs, Datapoints}} , which doesn't in fact call a function, but simply evaluates Exprs using eval_exprs/2 , with the pre-bound variables Value = undefined and DPs = Datapoints . Examples: An entry that returns a subset of erlang:memory() : exometer : new ( [ mem ] , { function , erlang , memory , [ ] , proplist , [ total , processes ] } ) . An entry that reports the heap size and message queue length of the code server: exometer : new ( [ code_server , pinfo ] , { function , erlang , process_info , [ { &#39;$call&#39; , erlang , whereis , [ code_server ] } ] , proplist , [ heap_size , message_queue_len ] } ) . An entry that reports the heap size of the code server. exometer : new ( [ code_server , heap_size ] , { function , erlang , process_info , [ { &#39;$call&#39; , erlang , whereis , [ code_server ] } , &#39;$dp&#39; ] , tagged , [ heap_size ] } ) . An entry that does pattern-matching on the return value ( erlang:statistics(garbage_collection) returns {GCs, Reclaimed, 0} ). exometer : new ( [ gc ] , { function , erlang , statistics , [ garbage_collection ] , match , { gcs , reclaimed , &#39;_&#39; } } , [ ] ) . An entry that calls erlang:processes() and evaluates a list of expressions that calculate the length of the returned list. exometer : new ( [ ps ] , { function , erlang , processes , [ ] , eval , { [ { l , [ { t , [ value , { call , length , [ { v , &#39;Value&#39; } ] } ] } ] } ] , [ value ] } } , [ ] ) . An entry that simply builds a list of datapoints, using the abstract syntax. exometer : new ( [ stub ] , { function , { eval , [ { l , [ { t , [ { a , 1 } ] } , { t , [ { b , 2 } ] } ] } ] , [ a , b ] } } , [ ] ) .","ref":"exometer_function.html#new/3"},{"type":"function","title":"exometer_function.preprocess_setopts/5","doc":null,"ref":"exometer_function.html#preprocess_setopts/5"},{"type":"function","title":"exometer_function.reset/3","doc":null,"ref":"exometer_function.html#reset/3"},{"type":"function","title":"exometer_function.sample/3","doc":null,"ref":"exometer_function.html#sample/3"},{"type":"function","title":"exometer_function.setopts/3","doc":null,"ref":"exometer_function.html#setopts/3"},{"type":"function","title":"exometer_function.test_mem_info/1","doc":null,"ref":"exometer_function.html#test_mem_info/1"},{"type":"function","title":"exometer_function.update/4","doc":null,"ref":"exometer_function.html#update/4"},{"type":"type","title":"exometer_function.arg/0","doc":null,"ref":"exometer_function.html#t:arg/0"},{"type":"type","title":"exometer_function.arg_spec/0","doc":null,"ref":"exometer_function.html#t:arg_spec/0"},{"type":"type","title":"exometer_function.binding/0","doc":null,"ref":"exometer_function.html#t:binding/0"},{"type":"type","title":"exometer_function.datapoints/0","doc":null,"ref":"exometer_function.html#t:datapoints/0"},{"type":"type","title":"exometer_function.expr/0","doc":null,"ref":"exometer_function.html#t:expr/0"},{"type":"type","title":"exometer_function.expr_action/0","doc":null,"ref":"exometer_function.html#t:expr_action/0"},{"type":"type","title":"exometer_function.expr_atom/0","doc":null,"ref":"exometer_function.html#t:expr_atom/0"},{"type":"type","title":"exometer_function.expr_binary_op/0","doc":null,"ref":"exometer_function.html#t:expr_binary_op/0"},{"type":"type","title":"exometer_function.expr_call/0","doc":null,"ref":"exometer_function.html#t:expr_call/0"},{"type":"type","title":"exometer_function.expr_case/0","doc":null,"ref":"exometer_function.html#t:expr_case/0"},{"type":"type","title":"exometer_function.expr_clause/0","doc":null,"ref":"exometer_function.html#t:expr_clause/0"},{"type":"type","title":"exometer_function.expr_descr/0","doc":null,"ref":"exometer_function.html#t:expr_descr/0"},{"type":"type","title":"exometer_function.expr_erl/0","doc":null,"ref":"exometer_function.html#t:expr_erl/0"},{"type":"type","title":"exometer_function.expr_fold/0","doc":null,"ref":"exometer_function.html#t:expr_fold/0"},{"type":"type","title":"exometer_function.expr_guard/0","doc":"Must all return 'true'.","ref":"exometer_function.html#t:expr_guard/0"},{"type":"type","title":"exometer_function.expr_int/0","doc":null,"ref":"exometer_function.html#t:expr_int/0"},{"type":"type","title":"exometer_function.expr_list/0","doc":null,"ref":"exometer_function.html#t:expr_list/0"},{"type":"type","title":"exometer_function.expr_match/0","doc":null,"ref":"exometer_function.html#t:expr_match/0"},{"type":"type","title":"exometer_function.expr_op/0","doc":null,"ref":"exometer_function.html#t:expr_op/0"},{"type":"type","title":"exometer_function.expr_operator/0","doc":null,"ref":"exometer_function.html#t:expr_operator/0"},{"type":"type","title":"exometer_function.expr_pattern/0","doc":null,"ref":"exometer_function.html#t:expr_pattern/0"},{"type":"type","title":"exometer_function.expr_string/0","doc":null,"ref":"exometer_function.html#t:expr_string/0"},{"type":"type","title":"exometer_function.expr_tuple/0","doc":null,"ref":"exometer_function.html#t:expr_tuple/0"},{"type":"type","title":"exometer_function.expr_unary_op/0","doc":null,"ref":"exometer_function.html#t:expr_unary_op/0"},{"type":"type","title":"exometer_function.extended_fun/0","doc":null,"ref":"exometer_function.html#t:extended_fun/0"},{"type":"type","title":"exometer_function.fun_name/0","doc":null,"ref":"exometer_function.html#t:fun_name/0"},{"type":"type","title":"exometer_function.fun_rep/0","doc":null,"ref":"exometer_function.html#t:fun_rep/0"},{"type":"type","title":"exometer_function.fun_spec/0","doc":null,"ref":"exometer_function.html#t:fun_spec/0"},{"type":"type","title":"exometer_function.mod_name/0","doc":null,"ref":"exometer_function.html#t:mod_name/0"},{"type":"type","title":"exometer_function.res_type/0","doc":null,"ref":"exometer_function.html#t:res_type/0"},{"type":"type","title":"exometer_function.simple_fun/0","doc":null,"ref":"exometer_function.html#t:simple_fun/0"},{"type":"module","title":"exometer_histogram","doc":"Exometer histogram probe behavior This module implements histogram metrics. Each histogram is a sliding window, for which the following datapoints are calculated: * max : the maximum value * min : the minimum value * mean : the arithmetic mean * median : the median * 50|75|90|95|97|99 : percentiles * 999 : the 99.9th percentile * n : the number of values used in the calculation (Note) Two histogram implementations are supported and can be selected using the option histogram_module : * exometer_slide implements a sliding window, which saves all elements within the window. Updating the histogram is cheap, but calculating the datapoints may be expensive depending on the size of the window. * exometer_slot_slide (default), aggregates mean, min and max values within given time slots, thereby reducing the amount of data kept for datapoint calculation. The update overhead should be insignificant. However, some loss of precision must be expected. To achieve slightly better accuracy of percentiles, 'extra values' are kept (every 4th value). For the calculation, extra vaules are included in the set until a suitable number has been reached (up to 600). Note that n reflects the number of values used in the calculation - not the number of updates made within the time window. Supported options: * time_span (default: 60000 ) size of the window in milliseconds. * slot_period (default: 10 ) size of the time slots in milliseconds. * histogram_module (default: exometer_slot_slide ). * truncate (default: true ) whether to truncate the datapoint values. Supported values: true | false | round , where round means to round the value rather than truncating it. * keep_high (default: 0 ) number of top values to actually keep. The keep_high option can be used to get better precision for the higher percentiles. A bounded buffer (see exometer_shallowtree ) is used to store the highest values, and these values are used to calculate the exact higher percentiles, as far as they go. For example, if the window saw 10,000 values, and the 1000 highest values are kept, these can be used to determine the percentiles 90 and up.","ref":"exometer_histogram.html"},{"type":"function","title":"exometer_histogram.average_sample/3","doc":null,"ref":"exometer_histogram.html#average_sample/3"},{"type":"function","title":"exometer_histogram.average_transform/2","doc":null,"ref":"exometer_histogram.html#average_transform/2"},{"type":"function","title":"exometer_histogram.behaviour/0","doc":null,"ref":"exometer_histogram.html#behaviour/0"},{"type":"function","title":"exometer_histogram.datapoints/0","doc":null,"ref":"exometer_histogram.html#datapoints/0"},{"type":"function","title":"exometer_histogram.probe_code_change/3","doc":null,"ref":"exometer_histogram.html#probe_code_change/3"},{"type":"function","title":"exometer_histogram.probe_get_datapoints/1","doc":null,"ref":"exometer_histogram.html#probe_get_datapoints/1"},{"type":"function","title":"exometer_histogram.probe_get_value/2","doc":null,"ref":"exometer_histogram.html#probe_get_value/2"},{"type":"function","title":"exometer_histogram.probe_handle_msg/2","doc":null,"ref":"exometer_histogram.html#probe_handle_msg/2"},{"type":"function","title":"exometer_histogram.probe_init/3","doc":null,"ref":"exometer_histogram.html#probe_init/3"},{"type":"function","title":"exometer_histogram.probe_reset/1","doc":null,"ref":"exometer_histogram.html#probe_reset/1"},{"type":"function","title":"exometer_histogram.probe_sample/1","doc":null,"ref":"exometer_histogram.html#probe_sample/1"},{"type":"function","title":"exometer_histogram.probe_setopts/3","doc":null,"ref":"exometer_histogram.html#probe_setopts/3"},{"type":"function","title":"exometer_histogram.probe_terminate/1","doc":null,"ref":"exometer_histogram.html#probe_terminate/1"},{"type":"function","title":"exometer_histogram.probe_update/2","doc":null,"ref":"exometer_histogram.html#probe_update/2"},{"type":"function","title":"exometer_histogram.test_run/1","doc":"Equivalent to test_run(Module, 1) .","ref":"exometer_histogram.html#test_run/1"},{"type":"function","title":"exometer_histogram.test_run/2","doc":"Test the performance and accuracy of a histogram callback module. This function uses a test set ( test_series/0 ) and initializes and updates a histogram using the callback module Module . The Module argument can either be the module name, or {ModName, Opts} where Opts are options passed on to the histogram module. Interval is the gap in milliseconds between the inserts. The test run will not actually wait, but instead manipulate the timestamp. Return value: [Result1, Result2] , where the results are {Time1, Time2, Datapoints} . Time1 is the time (in microsecs) it took to insert the values. Time2 is the time it took to calculate all default datapoints. The data set is shuffled between the two runs.","ref":"exometer_histogram.html#test_run/2"},{"type":"function","title":"exometer_histogram.test_series/0","doc":"Create a series of values for histogram testing. These are the properties of the current test set (note: bear no longer in use): 1 &gt; rp ( bear : get_statistics ( exometer_histogram : test_series ( ) ) ) . [ { min , 3 } , { max , 100 } , { arithmetic_mean , 6.696 } , { geometric_mean , 5.546722009408586 } , { harmonic_mean , 5.033909932832006 } , { median , 5 } , { variance , 63.92468674297564 } , { standard_deviation , 7.995291535833802 } , { skewness , 7.22743137858698 } , { kurtosis , 59.15674033499604 } , { percentile , [ { 50 , 5 } , { 75 , 7 } , { 90 , 8 } , { 95 , 9 } , { 99 , 50 } , { 999 , 83 } ] } , { histogram , [ { 4 , 2700 } , { 5 , 1800 } , { 6 , 900 } , { 7 , 1800 } , { 8 , 900 } , { 9 , 720 } , { 53 , 135 } , { 83 , 36 } , { 103 , 9 } ] } , { n , 9000 } ]","ref":"exometer_histogram.html#test_series/0"},{"type":"module","title":"exometer_info","doc":"Accessor function for exometer data structures This module uses the exprecs transform (see exprecs ) to generate accessor functions for exometer data structures. Note that the value attribute in exometer_entry{} records may not represent the true value of the metric, since exometer entries often have structured values, or are represented as CRDTs for update efficiency.","ref":"exometer_info.html"},{"type":"function","title":"exometer_info.pp/1","doc":"Pretty-print a record, or list containing records. This function pretty-prints a record as {RecordName, [{Attr,Value}]} , or, if the input is a list, recognizes records and pretty-prints them, leaving other data structures unchanged.","ref":"exometer_info.html#pp/1"},{"type":"function","title":"exometer_info.pp_find/1","doc":"Performs exometer:find_entries(Path) &amp; returns pretty-printed result. This function calls `exometer:find_entries(Path) , retrieves the entry for each matching metric, and calls pp(Entry) for each entry.","ref":"exometer_info.html#pp_find/1"},{"type":"function","title":"exometer_info.pp_lookup/1","doc":"Performs a lookup by name of entry and pretty-prints the result. This function returns undefined if the entry cannot be found.","ref":"exometer_info.html#pp_lookup/1"},{"type":"function","title":"exometer_info.pp_select/1","doc":"Performs exometer:select(Pattern) &amp; returns pretty-printed result. This function calls `exometer:select(Pattern) , retrieves the entry for each matching metric, and calls pp(Entry) for each entry. Note that the match body of the select pattern must produce the full {Name, Type, Status} object, e.g. by specifying ['$_'] .","ref":"exometer_info.html#pp_select/1"},{"type":"function","title":"exometer_info.status/1","doc":"Return the operational status of the given exometer entry. The status attribute is overloaded in the #exometer_entry{} record. This function extracts the correct status ( enabled | disabled ).","ref":"exometer_info.html#status/1"},{"type":"type","title":"exometer_info.pp/0","doc":null,"ref":"exometer_info.html#t:pp/0"},{"type":"behaviour","title":"exometer_probe","doc":"Interface library for managing probes. This library contains the main API for accessing all probes executing in exometer. All exported functions in the exomter_probe module are invoked by the exometer module; a developer will not have to call exometer_probe functions directly. A probe is an implementation of the exometer_probe behavior which runs in its own process in order to collect data to be handled and reported by exometer. The implementation will be invoked through the exomoeter_probe module, which, as stated above, in its turn is invoked by the exometer module. A custom exometer probe is invoked by mapping a type to the module name of the custom exometer probe module. All metrics created with the given type will trigger the invocation of the new probe module. See Configuring type - entry maps for details on how to setup such maps. If the data can be collected at a high speed, and without blocking, an exometer_entry implementation can be used instead to do the gathering in-process. A probe is created throgh the exomter_probe:new/3 call, which in its turn is called by exometer:new/3 . During probe creation, a new process is spawned to handle the probe and call its implementation. While the created process is not a gen_server, it behaves similarly and provides a state to all implementation calls. Once running, the probe collects data from a subsystem, such as /proc , sysfs , and netlink , through timer-based calls to Mod:probe_sample/1 or explicit calls to Mod:probe_update/2 . A probe implementation can support any number of data points, where each data point is a specifric sample from the probe. For example, a probe that measures network traffic would have rx_packets , tx_packets , errors , dropped , and other data points reported by ifconfig(8) and ip(8) . Values are retrieved from the probe through the Mod:probe_get_value/2 call, which specifies the data points to be returned. The probe is expected to gather the given data points and return them to the caller. The probe callback interface The following functions are to be implemented and exported by a probe implementation. behaviour/0 The Mod:behaviour/0 function for an entry implementation should return the atom probe . This function will be involved by the exometer system in order to determine if a callback is an entry or a probe. probe_init/3 The Mod:probe_init/3 function is invoked as follows: probe_init ( Name , Type , Options ) The implementation shall initiate the probe, create the necessary state, and return it for future access through Mod:probe_update/2 , Mod:probe_sample/1 and Mod:probe_get_value/2 calls. The arguments are as follows: + Name Specifies the name of the metric to be created as a list of atoms. + Type Specifies the type provided to the exometer:new/3 call (before it was translated by the type - exometer probe map). It can be used if several different types are mapped to the same probe module. + Options Specifies an option list that contains additional setup directives to the probe. The actual options to support are a combination of the standard options, described below, and probe specific options processed by Mod:probe_init/3 . Standard options are processed directly by new/3 , before Mod:probe_init/3 is called, and are as follows: + {priority, P} Will be forwarded by the probe's process to erlang:process_flag/2 . + {min_heap_size, S} Will be forwarded by the probe's process to erlang:process_flag/2 . + {min_bin_vheap_size, S} Will be forwarded by the probe's process to erlang:process_flag/2 . + {sensitive, true | false} Will be forwarded by the probe's process to erlang:process_flag/2 . + {sample_interval, t} Specifies the interval, in milliseconds, that exometer_probe:sample/1 . should be invoked at. The Mod:probe_init/3 implementation is invoked by exometer:new/3 , which calls exometer_probe:new/3 , which invokes the probe implementation.. The Mod:probe_init/3 function shall return {ok, State} where State is a tuple that will be provided as a the State argument to all future probe implementation calls for the metric. If the sample_interval option has been specified in Opts , Mod:probe_sample/2 will be invoked immediately after Mod:probe_init/2 returns to retrieve a first sample. After that, Mod:probe_sample/2 will repeatedly will be called by the probe process at the millisecond-specified interval. Should Mod:probe_init/3 return antyhing else but {ok, State} , invoking new/3 call will fail. probe_terminate/1 The Mod:probe_terminate/1 function is invoked as follows: probe_terminate ( State ) The custom probe shall release any resources associated with the given state and return ok . The arguments are as follows: + State The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. The Mod:probe_terminate/1 implementation is invoked by exometer:delete/1 , which calls exometer_probe:delete/3 , which invokes the probe implementation. probe_setopts/3 The Mod:probe_setopts/2 function is invoked as follows: probe_setopts ( Entry , Opts , State ) The Mod:probe_setopts/4 implementation is invoked by exometer:setopts/3 , which calls exometer_probe:setopts/3 , which invokes the probe implementation. The implementation of this function shall modify the options of a probe. The setopts/3 function, which will process standard options before invoking Mod:probe_setopts/4 with the remaining options. See the documentation for Mod:probe_init/3 for details. The arguments are as follows: + Entry The (opaque) exometer entry record. See exometer_info for information on how to inspect the data structure. + Opts The probe-specific options to be processed. + Status The new status of the entry. + State The probe state, originally returned by Mod:probe_init/3 and subsequently modified by other probe implementation calls. This function shall return {ok, NewState} where NewState is the modified probe state that incorporates the new options. probe_update/2 The Mod:probe_update/2 function is invoked as follows: probe_update ( Value , State ) Incorporate a new value into the metric maintained by the metric. The arguments are as follows: + Value The value to integrate. + State The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. This function can be called outside the periodic Mod:probe_sample/1/ call to have the probe process a value given in Value . The Mod:probe_update/2 implementation is invoked by exometer:update/2 , which calls exometer_probe:update/4 , which invokes the probe implementation. Once processed, Mod:probe_update/2 shall return {ok, NewState} , where NewState contains the new probe state with the processed value. probe_get_value/2 The Mod:probe_get_value/2 function is invoked as follows: probe_get_value ( DataPoints , State ) The Mod:probe_get_value/2 implementation shall retrieve the value of one or more data points from the probe. The arguments are as follows: + DataPoints List of data point atoms to retrieve values for. + State The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. The Mod:probe_get_value/2 implementation is invoked by exometer:get_value/2 , which calls exometer_probe:get_value/4 , which invokes the probe implementation. If exometer:get_value/2 is invoked with default as a single data point, the probe's Mod:probe_get_datapoints/1 function will be called to retrieve all data points supported by the probe implementation. Mod:probe_get_value/2 will then be called with the returned set of data points provided as an argument. This function shall return the value of all data points provided in DataPoints , given that they are supported. The list in the returned tuple shall have the format: [ { DP , Val } , . . . ] Where DP one of the data points in the DataPoints argument, and Val is the value of that data point. If one of the argument-provided data points are not supported by the probe, the tuple returned for that data point shall be { DP, {error, undefined} . For example, if the provided DataPoint argument is set to [ min, max, xyzzy ] , and only min and max are supported by the probe, the returned list shall look like below: [ { min , 0.1265 } , { max , 3338.21 } , { xyzzy , { error , unsupported } ] The Mod:probe_get_value/2 implementation shall return {ok, List} , where List is the list of data points and their values described above. No new state is returned by this function. probe_get_datapoints/1 The Mod:probe_get_datapoints/1 function is invoked as follows: probe_get_datapoints ( State ) The Mod:probe_get_datapoints/1 shall return a list with all data points supported by the probe The arguments are as follows: + State The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. The Mod:probe_get_datapoints/1 implementation is invoked by exometer:info/2 , which calls exometer_probe:get_datapoints/3 , which invokes the probe implementation. In cases where exometer:get_value/2 is called with default as a single data point, Mod:probe_get_datapoints/1 is also called to retrieve a list of all supported data points, which is then forwarded to Mod:probe_get_value/2 . The implementation of Mod:probe_get_datapoints/1 shall return {ok, DpList} , where DpList is a list of data point atoms supported by the probe. probe_reset/1 The Mod:probe_reset/1 function is invoked as follows: probe_reset ( State ) The Mod:probe_reset/1 shall reset the state of the probe to its initial state. The arguments are as follows: + State The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. The Mod:probe_reset/1 implementation is invoked by exometer:reset/1 , which calls exometer_probe:reset/3 , which invokes the probe implementation. The implementation of Mod:probe_reset/1 shall return {ok, NewState} , where NewState contains the reset state of the probe. probe_sample/1 The Mod:probe_sample/1 function is invoked as follows: probe_sample ( State ) The Mod:probe_sample/1 implementation shall sample data from the subsystem the probe is integrated with. The arguments are as follows: + State The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. When invoked, Mod:probe_sample/1 is expected to interface the sub-system (/proc, /sysfs, etc) monitored by the probe, extract the relevant data from it, and return an updated probe state that incorporates the extracted data. The Mod:probe_sample/1 function is invoked by the probe thread at intervals specified by the {sample_interval, Intv} option provided to exometer_probe:new/3 . If this option is missing, or set to infinity, Mod:probe_sample/1 will never be called. The implementation of Mod:probe_sample/1 shall return {ok, NewState} , where NewState contains the new state of the probe with the sampled data integrated into it. probe_handle_msg/2 The Mod:probe_handle_msg/2 function is invoked as follows: probe_handle_msg ( Msg , State ) The Mod:probe_handle_msg/1 is invoked to process messages received by the probe process. The arguments are as follows: + State The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. + Msg The probe state, originally returned by Mod:probe_init/3 and subsequentially modified by other probe implementation calls. The implementation of this function will be called by the probe's process when it receives a message that is not recognized by the internal receive loop. The implementation of Mod:probe_handle_msg/2 shall return {ok, NewState} , where NewState contains the new state of the probe that reflects the processed message. Fault tolerance Probes are supervised by the exometer_admin process, and can be restarted after a crash. Restart parameters are provided via the option {restart, Params} , where Params is a list of {Frequency, Action} tuples. Frequency is either {Count, MilliSecs} or '_ ', and the corresponding Action :: restart | disable | delete will be performed if the frequency of restarts falls within the given limit. For example, [{{3, 1000}, restart}] will allow 3 restarts within a 1-second window. The matching is performed from top to bottom, and the first matching pattern is acted upon. If no matching pattern is found, the default action is delete . A pattern {'_', Action} acts as a catch-all, and should be put last in the list. It is also possible to specify {{Count, '_'}, Action} , which means that a total of Count restarts is permitted, regardless of how far apart they are. The count is reset after each restart. Example: { restart , [ { { 3 , 1000 } , restart } , % up to 3 restarts within 1 sec { { 4 , &#39;_&#39; } , disable } , % a total of up to 4 restarts { &#39;_&#39; , delete } ] } % anything else","ref":"exometer_probe.html"},{"type":"function","title":"exometer_probe.behaviour/0","doc":null,"ref":"exometer_probe.html#behaviour/0"},{"type":"callback","title":"exometer_probe.behaviour/0","doc":null,"ref":"exometer_probe.html#c:behaviour/0"},{"type":"function","title":"exometer_probe.delete/3","doc":null,"ref":"exometer_probe.html#delete/3"},{"type":"function","title":"exometer_probe.get_datapoints/3","doc":null,"ref":"exometer_probe.html#get_datapoints/3"},{"type":"function","title":"exometer_probe.get_value/3","doc":null,"ref":"exometer_probe.html#get_value/3"},{"type":"function","title":"exometer_probe.get_value/4","doc":null,"ref":"exometer_probe.html#get_value/4"},{"type":"function","title":"exometer_probe.new/3","doc":null,"ref":"exometer_probe.html#new/3"},{"type":"callback","title":"exometer_probe.probe_code_change/3","doc":null,"ref":"exometer_probe.html#c:probe_code_change/3"},{"type":"callback","title":"exometer_probe.probe_get_datapoints/1","doc":null,"ref":"exometer_probe.html#c:probe_get_datapoints/1"},{"type":"callback","title":"exometer_probe.probe_get_value/2","doc":null,"ref":"exometer_probe.html#c:probe_get_value/2"},{"type":"callback","title":"exometer_probe.probe_handle_msg/2","doc":null,"ref":"exometer_probe.html#c:probe_handle_msg/2"},{"type":"callback","title":"exometer_probe.probe_init/3","doc":null,"ref":"exometer_probe.html#c:probe_init/3"},{"type":"callback","title":"exometer_probe.probe_reset/1","doc":null,"ref":"exometer_probe.html#c:probe_reset/1"},{"type":"callback","title":"exometer_probe.probe_sample/1","doc":null,"ref":"exometer_probe.html#c:probe_sample/1"},{"type":"callback","title":"exometer_probe.probe_setopts/3","doc":null,"ref":"exometer_probe.html#c:probe_setopts/3"},{"type":"callback","title":"exometer_probe.probe_terminate/1","doc":null,"ref":"exometer_probe.html#c:probe_terminate/1"},{"type":"callback","title":"exometer_probe.probe_update/2","doc":null,"ref":"exometer_probe.html#c:probe_update/2"},{"type":"function","title":"exometer_probe.reset/3","doc":null,"ref":"exometer_probe.html#reset/3"},{"type":"function","title":"exometer_probe.restart/4","doc":null,"ref":"exometer_probe.html#restart/4"},{"type":"function","title":"exometer_probe.sample/3","doc":null,"ref":"exometer_probe.html#sample/3"},{"type":"function","title":"exometer_probe.setopts/3","doc":null,"ref":"exometer_probe.html#setopts/3"},{"type":"function","title":"exometer_probe.update/4","doc":null,"ref":"exometer_probe.html#update/4"},{"type":"module","title":"exometer_proc","doc":"Utility functions for the exometer_proc probe type. The exometer_proc probe type is a vanilla Erlang process. All messages must be handled explicitly. The functions in this module can be used by custom types (see e.g. exometer_spiral ). When the exometer_proc type is specified explicitly, the process is started automatically, and the following messages: lang = &quot;erlang&quot; { exometer_proc , { update , Value } } { exometer_proc , sample } { exometer_proc , reset } { exometer_proc , { Pid , Ref } , { get_value , Datapoints } } -&gt; { Ref , Reply } { exometer_proc , { Pid , Ref } , { setopts , Opts } } -&gt; { Ref , Reply } { exometer_proc , stop }","ref":"exometer_proc.html"},{"type":"function","title":"exometer_proc.call/2","doc":"Make a synchronous call to an exometer_proc process. Note that the receiving process must explicitly handle the message in a receive clause and respond properly. The protocol is: lang = &quot;erlang&quot; call ( Pid , Req ) - &amp; gt ; MRef = erlang : monitor ( process , Pid ) , Pid ! { exometer_proc , { self ( ) , MRef } , Req } , receive { MRef , Reply } - &amp; gt ; Reply after 5000 - &amp; gt ; error ( timeout ) end .","ref":"exometer_proc.html#call/2"},{"type":"function","title":"exometer_proc.cast/2","doc":"Send an asynchronous message to an exometer_proc process. This function sends a message on the form {exometer_proc, Msg} to the given process.","ref":"exometer_proc.html#cast/2"},{"type":"function","title":"exometer_proc.format_status/2","doc":null,"ref":"exometer_proc.html#format_status/2"},{"type":"function","title":"exometer_proc.handle_system_msg/4","doc":null,"ref":"exometer_proc.html#handle_system_msg/4"},{"type":"function","title":"exometer_proc.process_options/1","doc":"Apply process_flag-specific options.","ref":"exometer_proc.html#process_options/1"},{"type":"function","title":"exometer_proc.spawn_process/2","doc":"Spawn an exometer_proc process. This function sets up appropriate monitoring, and calls the function F which needs to initialize the probe and enter an event loop. (Note: exometer_proc processes are responsible for their own event loop).","ref":"exometer_proc.html#spawn_process/2"},{"type":"function","title":"exometer_proc.spawn_process/3","doc":null,"ref":"exometer_proc.html#spawn_process/3"},{"type":"function","title":"exometer_proc.stop/0","doc":"Terminate probe process in an orderly way. This function doesn't return.","ref":"exometer_proc.html#stop/0"},{"type":"function","title":"exometer_proc.system_code_change/4","doc":null,"ref":"exometer_proc.html#system_code_change/4"},{"type":"function","title":"exometer_proc.system_continue/3","doc":null,"ref":"exometer_proc.html#system_continue/3"},{"type":"function","title":"exometer_proc.system_terminate/4","doc":null,"ref":"exometer_proc.html#system_terminate/4"},{"type":"behaviour","title":"exometer_report","doc":"A custom reporter plugin, executing in its own process, can receive updated metric values by having its module referenced in an exometer_report:subscribe() call. The reporter, once it is setup as a subscription destination, will receive periodic calls with updated metrics and data points to be reported. Each custom plugin implements the exometer_report behavior. The life cycle of a a custom reporter consists of the following steps. + Reporter creation exometer_init/1 is invoked by exometer when the reporter is configured in the reporter application environment. See Configuring reporter plugins for details. + Setup subscription When exometer_report:subscribe() is called, targeting the custom report plugin, the gen_server's exometer_subscribe() function will be invoked to notify the plugin of the new metrics subscription. + Report Metrics Updated metrics are sent by exometer to the exometer_report/4 . All reported metrics will have been notified to the recipient through a previous exometer_report() function. + Tear down subscription When exometer_report:unsubscribe() is called, addressing the custom report plugin, the recipient's Mod:exometer_unsubscribe/4 function will be invoked to notify the plugin of the deleted subscription. The following chapters details each of the callbacks to be implemented in the exometer_report behavior. exometer_init/1 The exometer_init() function is invoked as follows: exometer_init ( Options ) The custom reporter plugin should create the necessary state for the new plugin and return a state to be used in future plugin calls. + Options Provides the prop list with attributes from the application environment for the cusom recipient. See Configuring reporter plugins for The Mod:exometer_init/1 function should return {ok, State} where State is a tuple that will be provided as a reference argument to future calls made into the plugin. Any other return formats will cancel the creation of the custom reporting plugin. exometer_subscribe/5 The Mod:exometer_subscribe/5 function is invoked as follows: exometer_subscribe ( Metric , DataPoint , Interval , Extra , State ) The custom plugin can use this notification to modify and return its state in order to prepare for future calls to exometer_report() with the given meteric and data point. + Metric Specifies the metric that is now subscribed to by the plugin as a list of atoms. + DataPoint Specifies the data point within the subscribed-to metric as an atom, or a list of atoms. + Interval Specifies the interval, in milliseconds, that the subscribed-to value will be reported at, or an atom, referring to a named interval configured in the reporter. + Extra Specifies the extra data, which can be anything the reporter can understand. + State Contains the state returned by the last called plugin function. The exomoeter_subscribe() function should return {ok, State} where State is a tuple that will be provided as a reference argument to future calls made into the plugin. Any other return formats will generate an error log message by exometer. exometer_report/5 The Mod:exometer_report/5 function is invoked as follows: exometer_report ( Metric , DataPoint , Extra , Value , State ) The custom plugin will receive this call when a periodic subscription triggers and wants to report its current value through the plugin. The plugin should export the value to the external system it interfaces and return its possibly modified state. + Metric Specifies the metric that is to be reported. + DataPoint Specifies the data point or data points within the metric to be reported. + Extra Specifies the extra data, which can be anything the reporter can understand. + State Contains the state returned by the last called plugin function. The exometer_report() function should return {ok, State} where State is a tuple that will be provided as a reference argument to future calls made into the plugin. Any other return formats will generate an error log message by exometer. exometer_unsubscribe/4 The Mod:exometer_unsubscribe/4 function is invoked as follows: exometer_unsubscribe ( Metric , DataPoint , Extra , State ) The custom plugin can use this notification to modify and return its state in order to free resources used to maintain the now de-activated subscription. When this call returns, the given metric / data point will not be present in future calls to exometer_report/5 . + Metric Specifies the metric that is now subscribed to by the plugin as a list of atoms. + DataPoint Specifies the data point or data points within the subscribed-to metric as an atom or a list of atoms. + Extra Specifies the extra data, which can be anything the reporter can understand. + Value Specifies the value for the datapoint, which is reported. + State Contains the state returned by the last called plugin function. The Mod:exometer_unsubscribe/4 function should return {ok, State} where State is a tuple that will be provided as a reference argument to future calls made into the plugin. Any other return formats will generate an error log message by exometer. exometer_report_bulk/3 (Optional) If the option {report_bulk, true} has been given when starting the reporter, and this function is exported, it will be called as: exometer_report_bulk ( Found , Extra , State ) where Found has the format [{Metric, [{DataPoint, Value}|_]}|_] That is, e.g. when a select pattern is used, all found values are passed to the reporter in one message. If bulk reporting is not enabled, each datapoint/value pair will be passed separately to the exometer_report/5 function. If report_bulk was enabled, the reporter callback will get all values at once. Note that this happens also for single values, which are then passed as a list of one metric, with a list of one datapoint/value pair.","ref":"exometer_report.html"},{"type":"function","title":"exometer_report.add_reporter/2","doc":"Add a reporter. The reporter can be configured using the following options. Note that all options are also passed to the reporter callback module, which may support additional options. {module, atom()} - The name of the reporter callback module. If no module is given, the module name defaults to the given reporter name. {status, enabled | disabled} - The operational status of the reporter if enabled, the reporter will report values to its target. If disabled, the reporter process will be terminated and subscription timers canceled, but the subscriptions will remain, and it will also be possible to add new subscriptions to the reporter. {intervals, [named_interval()]} named_interval() :: {Name::atom(), Interval::pos_integer()} | {Name::atom(), Interval::time_ms(), delay()::time_ms()} | {Name::atom(), 'manual'} Define named intervals. The name can be used by subscribers, so that all subsriptions for a given named interval will be reported when the interval triggers. An optional delay (in ms) can be given: this will cause the first interval to start in Delay milliseconds. When all intervals are named at the same time, the delay parameter can be used to achieve staggered reporting. If the interval is specified as &#39; manual ', it will have to be triggered manually using trigger_interval/2 . {report_bulk, true | false} Pass all found datapoint/value pairs for a given subscription at once to the exometer_report_bulk/3 function, if it is exported, otherwise use exometer_report/4 as usual.","ref":"exometer_report.html#add_reporter/2"},{"type":"function","title":"exometer_report.call_reporter/2","doc":"Send a custom (synchronous) call to Reporter . This function is used to make a client-server call to a given reporter instance. Note that the reporter type must recognize the request.","ref":"exometer_report.html#call_reporter/2"},{"type":"function","title":"exometer_report.cast_reporter/2","doc":"Send a custom (asynchronous) cast to Reporter . This function is used to make an asynchronous cast to a given reporter instance. Note that the reporter type must recognize the message.","ref":"exometer_report.html#cast_reporter/2"},{"type":"function","title":"exometer_report.delete_interval/2","doc":"Delete a named interval.","ref":"exometer_report.html#delete_interval/2"},{"type":"function","title":"exometer_report.disable_me/2","doc":"Used by a reporter to disable itself. This function can be called from a reporter instance if it wants to be disabled, e.g. after exhausting a configured number of connection attempts. The arguments passed are the name of the reporter callback module and the module state, and are used to call the Mod:terminate/2 function.","ref":"exometer_report.html#disable_me/2"},{"type":"function","title":"exometer_report.disable_reporter/1","doc":"Disable Reporter . The reporter will be terminated, and all subscription timers will be canceled, but the subscriptions themselves and reporter metadata are kept.","ref":"exometer_report.html#disable_reporter/1"},{"type":"function","title":"exometer_report.enable_reporter/1","doc":"Enable Reporter . The reporter will be 'restarted' in the same way as if it had crashed and was restarted by the supervision logic, but without counting it as a restart. If the reporter was already enabled, nothing is changed.","ref":"exometer_report.html#enable_reporter/1"},{"type":"callback","title":"exometer_report.exometer_call/3","doc":null,"ref":"exometer_report.html#c:exometer_call/3"},{"type":"callback","title":"exometer_report.exometer_cast/2","doc":null,"ref":"exometer_report.html#c:exometer_cast/2"},{"type":"callback","title":"exometer_report.exometer_info/2","doc":null,"ref":"exometer_report.html#c:exometer_info/2"},{"type":"callback","title":"exometer_report.exometer_init/1","doc":null,"ref":"exometer_report.html#c:exometer_init/1"},{"type":"callback","title":"exometer_report.exometer_newentry/2","doc":null,"ref":"exometer_report.html#c:exometer_newentry/2"},{"type":"callback","title":"exometer_report.exometer_report/5","doc":null,"ref":"exometer_report.html#c:exometer_report/5"},{"type":"callback","title":"exometer_report.exometer_setopts/4","doc":null,"ref":"exometer_report.html#c:exometer_setopts/4"},{"type":"callback","title":"exometer_report.exometer_subscribe/5","doc":null,"ref":"exometer_report.html#c:exometer_subscribe/5"},{"type":"callback","title":"exometer_report.exometer_terminate/2","doc":null,"ref":"exometer_report.html#c:exometer_terminate/2"},{"type":"callback","title":"exometer_report.exometer_unsubscribe/4","doc":null,"ref":"exometer_report.html#c:exometer_unsubscribe/4"},{"type":"function","title":"exometer_report.get_intervals/1","doc":"List the named intervals for Reporter .","ref":"exometer_report.html#get_intervals/1"},{"type":"function","title":"exometer_report.list_metrics/0","doc":"Equivalent to list_metrics([]) .","ref":"exometer_report.html#list_metrics/0"},{"type":"function","title":"exometer_report.list_metrics/1","doc":"List all metrics matching Path , together with subscription status. This function performs a metrics search using exometer:find_entries/1 , then matches the result against known subscriptions. It reports, for each metric, the available data points, as well as which reporters subscribe to which data points.","ref":"exometer_report.html#list_metrics/1"},{"type":"function","title":"exometer_report.list_reporters/0","doc":"List the name and pid of each known reporter.","ref":"exometer_report.html#list_reporters/0"},{"type":"function","title":"exometer_report.list_subscriptions/1","doc":"List all subscriptions for Reporter .","ref":"exometer_report.html#list_subscriptions/1"},{"type":"function","title":"exometer_report.new_entry/1","doc":"Called by exometer whenever a new entry is created. This function is called whenever a new metric is created, giving each reporter the chance to enable a subscription for it. Note that each reporter is free to call the subscription management functions, as there is no risk of deadlock. The callback function triggered by this call is Mod:exometer_newentry(Entry, St) .","ref":"exometer_report.html#new_entry/1"},{"type":"function","title":"exometer_report.remove_reporter/1","doc":"Remove reporter and all its subscriptions.","ref":"exometer_report.html#remove_reporter/1"},{"type":"function","title":"exometer_report.remove_reporter/2","doc":"Remove Reporter (non-blocking call). This function can be used to order removal of a reporter with a custom reason. Note that the function is asynchronous, making it suitable e.g. for calling from within the reporter itself.","ref":"exometer_report.html#remove_reporter/2"},{"type":"function","title":"exometer_report.restart_intervals/1","doc":"Restart all named intervals, respecting specified delays. This function can be used if named intervals are added incrementally, and it is important that all intervals trigger separated by the given delays.","ref":"exometer_report.html#restart_intervals/1"},{"type":"function","title":"exometer_report.set_interval/3","doc":"Specify a named interval. See add_reporter/2 for a description of named intervals. The named interval is here specified as either Time (milliseconds) or {Time, Delay} , where a delay in milliseconds is provided. It is also specify an interval as &#39; manual ', indicating that the interval can only be triggered manually via trigger_interval/2 . If the named interval exists, it will be replaced with the new definition. Otherwise, it will be added. Use restart_intervals/1 if you want all intervals to be restarted/resynched with corresponding relative delays.","ref":"exometer_report.html#set_interval/3"},{"type":"function","title":"exometer_report.setopts/3","doc":"Called by exometer when options of a metric entry are changed. Reporters subscribing to the metric get a chance to process the options change in the function Mod:exometer_setopts(Metric,Options,Status,St) .","ref":"exometer_report.html#setopts/3"},{"type":"function","title":"exometer_report.start_link/0","doc":"Starts the server --------------------------------------------------------------------","ref":"exometer_report.html#start_link/0"},{"type":"function","title":"exometer_report.start_reporters/0","doc":null,"ref":"exometer_report.html#start_reporters/0"},{"type":"function","title":"exometer_report.subscribe/4","doc":"Equivalent to subscribe(Reporter, Metric, DataPoint, Interval, [], true) .","ref":"exometer_report.html#subscribe/4"},{"type":"function","title":"exometer_report.subscribe/5","doc":"Equivalent to subscribe(Reporter, Metric, DataPoint, Interval, Extra, false) .","ref":"exometer_report.html#subscribe/5"},{"type":"function","title":"exometer_report.subscribe/6","doc":"Add a subscription to an existing reporter. The reporter must first be started using add_reporter/2 , or through a static configuration. Metric is the name of an exometer entry. DataPoint is either a single data point (an atom) or a list of data points (a list). Interval is the sampling/reporting interval in milliseconds, or an atom, referring to a named interval configured in the reporter. The named interval need not be defined yet in the reporter (the subscription will not trigger until it is defined.) Extra can be anything that the chosen reporter understands (default: [] ). If the reporter uses exometer_util:report_type/3 , Extra should be a proplist, and the option {report_type, T} can control which type (e.g. for collectd or statsd) that the value corresponds to. Retry : boolean(). If true, retry the subscription at the next interval, even if the metric cannot be read.","ref":"exometer_report.html#subscribe/6"},{"type":"function","title":"exometer_report.terminate_reporter/1","doc":null,"ref":"exometer_report.html#terminate_reporter/1"},{"type":"function","title":"exometer_report.trigger_interval/2","doc":"Trigger a named interval. This function is mainly used to trigger intervals defined as &#39; manual ', but can be used to trigger any named interval. If a named interval with a specified time in milliseconds is triggered this way, it will effectively be restarted, and will repeat as usual from that point on.","ref":"exometer_report.html#trigger_interval/2"},{"type":"function","title":"exometer_report.unsubscribe/3","doc":"Equivalent to unsubscribe(Reporter, Metric, DataPoint, []) .","ref":"exometer_report.html#unsubscribe/3"},{"type":"function","title":"exometer_report.unsubscribe/4","doc":"Removes a subscription. Note that the subscription is identified by the combination {Reporter, Metric, DataPoint, Extra} . The exact information can be extracted using list_subscriptions/1 .","ref":"exometer_report.html#unsubscribe/4"},{"type":"function","title":"exometer_report.unsubscribe_all/2","doc":"Removes all subscriptions related to Metric in Reporter.","ref":"exometer_report.html#unsubscribe_all/2"},{"type":"type","title":"exometer_report.action/0","doc":null,"ref":"exometer_report.html#t:action/0"},{"type":"type","title":"exometer_report.datapoint/0","doc":null,"ref":"exometer_report.html#t:datapoint/0"},{"type":"type","title":"exometer_report.datapoints/0","doc":null,"ref":"exometer_report.html#t:datapoints/0"},{"type":"type","title":"exometer_report.delay/0","doc":null,"ref":"exometer_report.html#t:delay/0"},{"type":"type","title":"exometer_report.error/0","doc":null,"ref":"exometer_report.html#t:error/0"},{"type":"type","title":"exometer_report.extra/0","doc":null,"ref":"exometer_report.html#t:extra/0"},{"type":"type","title":"exometer_report.interval/0","doc":null,"ref":"exometer_report.html#t:interval/0"},{"type":"type","title":"exometer_report.maxR/0","doc":null,"ref":"exometer_report.html#t:maxR/0"},{"type":"type","title":"exometer_report.maxT/0","doc":null,"ref":"exometer_report.html#t:maxT/0"},{"type":"type","title":"exometer_report.metric/0","doc":null,"ref":"exometer_report.html#t:metric/0"},{"type":"type","title":"exometer_report.named_interval/0","doc":null,"ref":"exometer_report.html#t:named_interval/0"},{"type":"type","title":"exometer_report.options/0","doc":null,"ref":"exometer_report.html#t:options/0"},{"type":"type","title":"exometer_report.reporter_name/0","doc":"Restart specification","ref":"exometer_report.html#t:reporter_name/0"},{"type":"type","title":"exometer_report.restart/0","doc":null,"ref":"exometer_report.html#t:restart/0"},{"type":"type","title":"exometer_report.retry/0","doc":null,"ref":"exometer_report.html#t:retry/0"},{"type":"type","title":"exometer_report.time_ms/0","doc":null,"ref":"exometer_report.html#t:time_ms/0"},{"type":"behaviour","title":"exometer_report_logger","doc":"Exometer report collector and logger. This module implements a behavior for collecting reporting data and handling it (logging to disk or ets, printing to tty, etc.) The logger has built-in support for receiving input via UDP, TCP or internal Erlang messaging, as well as a plugin API for custom input handling. Correspondingly, it has support for output to TTY or ets, as well as a plugin API for custom output. An example of how the logger can be used can be found in test/exometer_test_udp_reporter.erl , which implements a UDP-based reporter as well as an input plugin and an output plugin. This reporter is used by test/exometer_report_SUITE.erl . Loggers can be combined, e.g. by creating one logger that receives Erlang messages, and other loggers that receive from different sources, prefix their reports and pass them on to the first logger. Input plugins An input plugin is initiated by Module:logger_init_input(State) , where State is whatever was given as a state option (default: undefined ). The function must create a process and return {ok, Pid} . Pid is responsible for setting up whatever input channel is desired, and passes on incoming data to the logger via Erlang messages {plugin, Pid, Data} . Output Chaining Each incoming data item is passed through the list of output operators. Each output operator is able to modify the data (the tty and ets operators leave the data unchanged). Output plugins receive the data in Module:logger_handle_data(Data, State) , which must return {NewData, NewState} . The state is private to the plugin, while NewData will be passed along to the next output operator. Flow control The logger will handle flow control automatically for udp and tcp inputs. If {active,once} or {active, false} , the logger will trigger {active, once} each time it has handled an incoming message. If {active, N} , it will &quot;refill&quot; the port each time it receives an indication that it has become passive. Input plugins create a process in Module:logger_init_input/1 . This process can mimick the behavior of Erlang ports by sending a {plugin_passive, Pid} message to the logger. The logger will reply with a message, {plugin_active, N} , where N is the value given by the active option.","ref":"exometer_report_logger.html"},{"type":"function","title":"exometer_report_logger.info/0","doc":"List active logger instances. This function lists the instances started via new/1 , along with their respective settings as nested property lists.","ref":"exometer_report_logger.html#info/0"},{"type":"function","title":"exometer_report_logger.info/1","doc":"Lists the settings of a given logger instance.","ref":"exometer_report_logger.html#info/1"},{"type":"callback","title":"exometer_report_logger.logger_handle_data/2","doc":null,"ref":"exometer_report_logger.html#c:logger_handle_data/2"},{"type":"callback","title":"exometer_report_logger.logger_init_input/1","doc":null,"ref":"exometer_report_logger.html#c:logger_init_input/1"},{"type":"callback","title":"exometer_report_logger.logger_init_output/1","doc":null,"ref":"exometer_report_logger.html#c:logger_init_output/1"},{"type":"function","title":"exometer_report_logger.new/1","doc":"Create a new logger instance. This function creates a logger process with the given input and output parameters. * {id, ID} is mainly for documentation and simplifying identification of instances returned by info/0 . * {input, PropList} specifies what the logger listens to. Only the first input entry is regarded, but the option is mandatory. * {output, PropList} specifies what the logger should to with received data. Multiple output entries are allowed, and they will be processed in the order given. Valid input options: * {mode, udp | tcp | internal | plugin} defines the protocol * {active, false | true | once | N} provides flow control. Default: true . * (mode-specific options) Valid output options: * {mode, tty | ets | plugin | internal} defines output types * (output-specific options) Mode-specific options, udp : * {port, integer()} - UDP port number * {options, list()} - Options to pass to gen_udp:open/2 Mode-specific options, tcp : * {port, integer()} - TCP port number * {options, list()} - Options to pass to gen_tcp:listen/2 Mode-specific options, tty : * {prefix, iolist()} - Prefix string inserted before the data, which is printed as-is (note that any delimiter would need to be part of the prefix) Mode-specific options, ets : * {table, ets:table()} - Ets table identifier. If not specified, an ordered-set table will be created by the logger process. The incoming data will be inserted as {os:timestamp(), Data} . Mode-specific options, internal : * {process, PidOrRegname} specifies another logger instance, which is to receive data from this logger (if used in output), or which is allowed to send to this logger (if used in input). If no process is given for input, any process can send data (on the form {exometer_report_logger, Pid, Data} ) to this logger. Mode-specific options, plugin : * {module, Module} - name of callback module (behaviour: exometer_report_logger ) * {state, State} - Passed as initial argument to Module:logger_init_input/1 or Module:logger_init_output/1 , depending on whether the plugin is specified as input or output.","ref":"exometer_report_logger.html#new/1"},{"type":"function","title":"exometer_report_logger.start_link/1","doc":"Start function for logger instance. This function is the start function eventually called as a result from new/1 , but whereas new/1 creates a supervised instance, this function simply creates the process. It would normally not be used directly.","ref":"exometer_report_logger.html#start_link/1"},{"type":"type","title":"exometer_report_logger.logger_info/0","doc":null,"ref":"exometer_report_logger.html#t:logger_info/0"},{"type":"type","title":"exometer_report_logger.proplist/0","doc":null,"ref":"exometer_report_logger.html#t:proplist/0"},{"type":"module","title":"exometer_report_tty","doc":"Custom reporting probe for Hosted Graphite. Collectd unix socket integration. All data subscribed to by the plugin (through exosense_report:subscribe()) will be reported to collectd.","ref":"exometer_report_tty.html"},{"type":"function","title":"exometer_report_tty.exometer_call/3","doc":null,"ref":"exometer_report_tty.html#exometer_call/3"},{"type":"function","title":"exometer_report_tty.exometer_cast/2","doc":null,"ref":"exometer_report_tty.html#exometer_cast/2"},{"type":"function","title":"exometer_report_tty.exometer_info/2","doc":null,"ref":"exometer_report_tty.html#exometer_info/2"},{"type":"function","title":"exometer_report_tty.exometer_init/1","doc":null,"ref":"exometer_report_tty.html#exometer_init/1"},{"type":"function","title":"exometer_report_tty.exometer_newentry/2","doc":null,"ref":"exometer_report_tty.html#exometer_newentry/2"},{"type":"function","title":"exometer_report_tty.exometer_report/5","doc":null,"ref":"exometer_report_tty.html#exometer_report/5"},{"type":"function","title":"exometer_report_tty.exometer_setopts/4","doc":null,"ref":"exometer_report_tty.html#exometer_setopts/4"},{"type":"function","title":"exometer_report_tty.exometer_subscribe/5","doc":null,"ref":"exometer_report_tty.html#exometer_subscribe/5"},{"type":"function","title":"exometer_report_tty.exometer_terminate/2","doc":null,"ref":"exometer_report_tty.html#exometer_terminate/2"},{"type":"function","title":"exometer_report_tty.exometer_unsubscribe/4","doc":null,"ref":"exometer_report_tty.html#exometer_unsubscribe/4"},{"type":"module","title":"exometer_shallowtree","doc":"Size-constrained leftist tree Inspired by Leftist Trees by Sartaj Sahni. The purpose of this module is to efficiently store a limited number of values in e.g. a lossy histogram (ex. exometer_slot_slide ). The complexity of insert operations is log(N), but once the tree is full, only values higher than the minimum value already in the tree will be inserted, and the old minimum is deleted - i.e. two O(log N) operations. For other values, the cost will be only two comparisons, since the top node in the tree always contains the minimum.","ref":"exometer_shallowtree.html"},{"type":"function","title":"exometer_shallowtree.fill1/2","doc":null,"ref":"exometer_shallowtree.html#fill1/2"},{"type":"function","title":"exometer_shallowtree.fill/1","doc":null,"ref":"exometer_shallowtree.html#fill/1"},{"type":"function","title":"exometer_shallowtree.filter/2","doc":null,"ref":"exometer_shallowtree.html#filter/2"},{"type":"function","title":"exometer_shallowtree.insert/3","doc":"Insert value V into tree T . If the tree is full and V is smaller than the minimum, this function will return immediately, leaving the tree unchanged.","ref":"exometer_shallowtree.html#insert/3"},{"type":"function","title":"exometer_shallowtree.limit/1","doc":"Returns the maximum number of values for the given tree.","ref":"exometer_shallowtree.html#limit/1"},{"type":"function","title":"exometer_shallowtree.new/1","doc":"Create an empty tree limited to Size .","ref":"exometer_shallowtree.html#new/1"},{"type":"function","title":"exometer_shallowtree.size/1","doc":"Returns the number of values stored in the given tree.","ref":"exometer_shallowtree.html#size/1"},{"type":"function","title":"exometer_shallowtree.take_min/1","doc":"Extract the smallest value from the tree T . If the tree is empty, error is returned, otherwise {Minimum, NewTree} .","ref":"exometer_shallowtree.html#take_min/1"},{"type":"function","title":"exometer_shallowtree.to_list/1","doc":"Converts a tree to a list. The list will not be ordered, since the aim is to produce the list as quickly as possible. Also, lists:sort(to_list(Tree)) , if to_list/1 uses brute force, seems faster than most approaches for extracting values in order.","ref":"exometer_shallowtree.html#to_list/1"},{"type":"type","title":"exometer_shallowtree.tree/0","doc":null,"ref":"exometer_shallowtree.html#t:tree/0"},{"type":"module","title":"exometer_slide","doc":"Efficient sliding-window buffer Initial implementation: 29 Sep 2009 by Tony Rogvall This module implements an efficient sliding window, maintaining two lists - a primary and a secondary. Values are paired with a timestamp (millisecond resolution, see exometer_util:timestamp/0 ) and prepended to the primary list. When the time span between the oldest and the newest entry in the primary list exceeds the given window size, the primary list is shifted into the secondary list position, and the new entry is added to a new (empty) primary list. The window can be converted to a list using to_list/1 or folded over using foldl/3 .","ref":"exometer_slide.html"},{"type":"function","title":"exometer_slide.add_element/2","doc":"Add an element to the buffer, tagging it with the current time. Note that the buffer is a sliding window. Values will be discarded as they move out of the specified time span.","ref":"exometer_slide.html#add_element/2"},{"type":"function","title":"exometer_slide.add_element/3","doc":"Add an element to the buffer, tagged with the given timestamp. Apart from the specified timestamp, this function works just like add_element/2 .","ref":"exometer_slide.html#add_element/3"},{"type":"function","title":"exometer_slide.add_element/4","doc":"Add an element to the buffer, optionally indicating if a swap occurred. This function works like add_element/3 , but will also indicate whether the sliding window buffer swapped lists (this means that the 'primary' buffer list became full and was swapped to 'secondary', starting over with an empty primary list. If Wrap == true , the return value will be {Bool,Slide} , where Bool==true means that a swap occurred, and Bool==false means that it didn't. If Wrap == false , this function works exactly like add_element/3 . One possible use of the Wrap == true option could be to keep a sliding window buffer of values that are pushed e.g. to an external stats service. The swap indication could be a trigger point where values are pushed in order to not lose entries.","ref":"exometer_slide.html#add_element/4"},{"type":"function","title":"exometer_slide.foldl/3","doc":"Fold over all values in the sliding window. The fun should as fun({Timestamp, Value}, Acc) -&gt; NewAcc . The values are processed in order from oldest to newest.","ref":"exometer_slide.html#foldl/3"},{"type":"function","title":"exometer_slide.foldl/4","doc":"Fold over the sliding window, starting from Timestamp . The fun should as fun({Timestamp, Value}, Acc) -&gt; NewAcc . The values are processed in order from oldest to newest.","ref":"exometer_slide.html#foldl/4"},{"type":"function","title":"exometer_slide.new/2","doc":"Create a new sliding-window buffer. Size determines the size in milliseconds of the sliding window. The implementation prepends values into a primary list until the oldest element in the list is Size ms older than the current value. It then swaps the primary list into a secondary list, and starts prepending to a new primary list. This means that more data than fits inside the window will be kept - upwards of twice as much. On the other hand, updating the buffer is very cheap.","ref":"exometer_slide.html#new/2"},{"type":"function","title":"exometer_slide.new/5","doc":"Callback function for exometer_histogram This function is not intended to be used directly. The arguments _SampleFun and _TransformFun are ignored.","ref":"exometer_slide.html#new/5"},{"type":"function","title":"exometer_slide.reset/1","doc":"Empty the buffer","ref":"exometer_slide.html#reset/1"},{"type":"function","title":"exometer_slide.to_list/1","doc":"Convert the sliding window into a list of timestamped values.","ref":"exometer_slide.html#to_list/1"},{"type":"type","title":"exometer_slide.cur_state/0","doc":null,"ref":"exometer_slide.html#t:cur_state/0"},{"type":"type","title":"exometer_slide.fold_acc/0","doc":null,"ref":"exometer_slide.html#t:fold_acc/0"},{"type":"type","title":"exometer_slide.fold_fun/0","doc":null,"ref":"exometer_slide.html#t:fold_fun/0"},{"type":"type","title":"exometer_slide.sample_fun/0","doc":null,"ref":"exometer_slide.html#t:sample_fun/0"},{"type":"type","title":"exometer_slide.timestamp/0","doc":null,"ref":"exometer_slide.html#t:timestamp/0"},{"type":"type","title":"exometer_slide.transform_fun/0","doc":null,"ref":"exometer_slide.html#t:transform_fun/0"},{"type":"type","title":"exometer_slide.value/0","doc":null,"ref":"exometer_slide.html#t:value/0"},{"type":"module","title":"exometer_slot_slide","doc":"Introduction This module defines a sliding time-window histogram with execution cost control. The problem with traditional histograms is that every sample is stored and processed, no matter what the desired resolution is. If a histogram has a sliding window of 100 seconds, and we have a sample rate of 100Hz will give us 10000 elements to process every time we want to calculate that average, which is expensive. The same goes for min/max finds, percentile calculations, etc. The solution is to introduce cost-control, where we can balance execution time against sample resolution. The obvious implementation is to lower the sample rate by throwing away samples and just store evey N samples. However, this will mean potentially missed min/max values, and other extreme data that is seen by the edge code but is thrown away. A slotted slide histogram will define a number of time slots, each spanning a fixed number of milliseconds. The slider then stores slots that cover a given timespan into the past (a rolling historgram). All slots older than the timespan are discarded. The &quot;current&quot; slot is defined as the time period between the time stamp of the last stored slot and the time when it is time to store the next slot. If the slot period (size) is 100ms, and the last slot was stored in the histogram at msec 1200, the current slot period ends at msec 1300. All samples received during the current slot are processed by a low-cost fun that updates the current slot state. When the current slot ends, another fun is used to transform the current slot state to a value that is stored in the histogram. If a simple average is to be calculated for all samples received, the sample-processing fun will add to the sum of the received samples, and increment sample counter. When the current slot expires, the result of SampleSum / SampleCount is stored in the slot. If min/max are to be stored by the slotted histograms, the current slot state would have a { Min, Max } tuple that is upadted with the smallest and largest values received during the period. At slot expiration the min/max tuple is simply stored, by the transformation fun, in the histogram slots. By adjusting the slot period and the total histogram duration, the cost of analysing the entire histogram can be balanced against the resolution of that analysis. SLOT HISTOGRAM MANAGEMENT The slide state maintains a list of { TimeStamp, SlotElem } slot tuples. TimeStamp is the time period (in monotonic ms), rounded down to the resolution of the slot period, and SlotElem is the tuple generated by the current slot transformation MFA. The list is sorted on descending time stamps (newest slot first). Normally each element in the list has a timestamp that is SlotPeriod milliseconds newer than the next slot in the list. However, if no samples are received during the current slot, no slot for that time stamp will be stored, leaving a hole in the list. Normally, the the slot list would look like this (with a 100 msec slot period and a simple average value): [ { 1400 , 23.2 } , { 1300 , 23.1 } , { 1200 , 22.8 } , { 1100 , 23.0 } ] If no samples were received during the period between 1200 and 1300 (ms), no slot would be stored at that time stamp, yielding the following list: [ { 1400 , 23.2 } , { 1300 , 23.1 } , { 1100 , 23.0 } ] This means that the total length of the slot list may vary, even if it always covers the same time span into the past. SLOT LISTS The slotted slider stores its slots in two lists, list1, and list2. list1 contains the newest slots. Once the oldest element in list1 is older than the time span covered by the histogram, the entire content of list1 is shifted into list2, and list1 is set to []. The old content of list2, if any, is discarded during the shift. When the content of the histogram is to be retrieved (through fold{l,r}(), or to_list()), the entire content of list1 is prepended to the part of list2 that is within than the time span covered by the histogram. If the time span of the histogram is 5 seconds, with a 1 second slot period, list1 can look like this : list1 = [ { 5000 , 1.2 } , { 4000 , 2.1 } , { 3000 , 2.0 } , { 2000 , 2.3 } , { 1000 , 2.8 } ] When the next slot is stored in the list, add_slot() will detect that the list is full since the oldest element ({1000, 20.8}) will fall outside the time span covered by the histogram. List1 will shifted to List2, and List1 will be set to the single new slot that is to be stored: list1 = [ { 6000 , 1.8 } ] list2 = [ { 5000 , 1.2 } , { 4000 , 2.1 } , { 3000 , 2.0 } , { 2000 , 2.3 } , { 1000 , 2.8 } ] To_list() and fold{l,r}() will return list1, and the first four elements of list2 in order to get a complete histogram covering the entire time span: [ { 6000 , 1.8 } , { 5000 , 1.2 } , { 4000 , 2.1 } , { 3000 , 2.0 } , { 2000 , 2.3 } ] SAMPLE PROCESSING AND TRANSFORMATION FUN Two funs are provided to the new() function of the slotted slide histogram. The processing function is called by add_element() and will take the same sample value provided to that function together with the current timestamp and slot state as arguments. The function will return the new current slot state. M : F ( TimeStamp , Value , State ) -&gt; NewState The first call to the sample processing fun when the current slot is newly reset (just after a slot has been added to the histogram), state will be set to 'undefined' M : F ( TimeStamp , Value , undefined ) -&gt; NewState The transformation fun is called when the current slot has expired and is to be stored in the histogram. It will receive the current timestamp and slot state as arguments and returns the element to be stored (together with a slot timestamp) in the slot histogram. M : F ( TimeStamp , State ) -&gt; Element Element will present in the lists returned by to_list() and fold{l,r}(). If the transformation MFA cannot do its job, for example because no samples have been processed by the sample processing fun, the transformation fun should return 'undefined' See new/2 and its avg_sample() and avg_transform() functions for an example of a simple average value implementation.","ref":"exometer_slot_slide.html"},{"type":"function","title":"exometer_slot_slide.add_element/2","doc":null,"ref":"exometer_slot_slide.html#add_element/2"},{"type":"function","title":"exometer_slot_slide.add_element/3","doc":null,"ref":"exometer_slot_slide.html#add_element/3"},{"type":"function","title":"exometer_slot_slide.add_element/4","doc":null,"ref":"exometer_slot_slide.html#add_element/4"},{"type":"function","title":"exometer_slot_slide.foldl/3","doc":null,"ref":"exometer_slot_slide.html#foldl/3"},{"type":"function","title":"exometer_slot_slide.foldl/4","doc":null,"ref":"exometer_slot_slide.html#foldl/4"},{"type":"function","title":"exometer_slot_slide.foldr/3","doc":null,"ref":"exometer_slot_slide.html#foldr/3"},{"type":"function","title":"exometer_slot_slide.foldr/4","doc":null,"ref":"exometer_slot_slide.html#foldr/4"},{"type":"function","title":"exometer_slot_slide.new/2","doc":null,"ref":"exometer_slot_slide.html#new/2"},{"type":"function","title":"exometer_slot_slide.new/4","doc":null,"ref":"exometer_slot_slide.html#new/4"},{"type":"function","title":"exometer_slot_slide.new/5","doc":null,"ref":"exometer_slot_slide.html#new/5"},{"type":"function","title":"exometer_slot_slide.reset/1","doc":null,"ref":"exometer_slot_slide.html#reset/1"},{"type":"function","title":"exometer_slot_slide.to_list/1","doc":null,"ref":"exometer_slot_slide.html#to_list/1"},{"type":"type","title":"exometer_slot_slide.cur_state/0","doc":null,"ref":"exometer_slot_slide.html#t:cur_state/0"},{"type":"type","title":"exometer_slot_slide.sample_fun/0","doc":null,"ref":"exometer_slot_slide.html#t:sample_fun/0"},{"type":"type","title":"exometer_slot_slide.timestamp/0","doc":null,"ref":"exometer_slot_slide.html#t:timestamp/0"},{"type":"type","title":"exometer_slot_slide.transform_fun/0","doc":null,"ref":"exometer_slot_slide.html#t:transform_fun/0"},{"type":"type","title":"exometer_slot_slide.value/0","doc":null,"ref":"exometer_slot_slide.html#t:value/0"},{"type":"module","title":"exometer_spiral","doc":null,"ref":"exometer_spiral.html"},{"type":"function","title":"exometer_spiral.behaviour/0","doc":null,"ref":"exometer_spiral.html#behaviour/0"},{"type":"function","title":"exometer_spiral.count_sample/3","doc":null,"ref":"exometer_spiral.html#count_sample/3"},{"type":"function","title":"exometer_spiral.count_transform/2","doc":null,"ref":"exometer_spiral.html#count_transform/2"},{"type":"function","title":"exometer_spiral.probe_code_change/3","doc":null,"ref":"exometer_spiral.html#probe_code_change/3"},{"type":"function","title":"exometer_spiral.probe_get_datapoints/1","doc":null,"ref":"exometer_spiral.html#probe_get_datapoints/1"},{"type":"function","title":"exometer_spiral.probe_get_value/2","doc":null,"ref":"exometer_spiral.html#probe_get_value/2"},{"type":"function","title":"exometer_spiral.probe_handle_msg/2","doc":null,"ref":"exometer_spiral.html#probe_handle_msg/2"},{"type":"function","title":"exometer_spiral.probe_init/3","doc":null,"ref":"exometer_spiral.html#probe_init/3"},{"type":"function","title":"exometer_spiral.probe_reset/1","doc":null,"ref":"exometer_spiral.html#probe_reset/1"},{"type":"function","title":"exometer_spiral.probe_sample/1","doc":null,"ref":"exometer_spiral.html#probe_sample/1"},{"type":"function","title":"exometer_spiral.probe_setopts/3","doc":null,"ref":"exometer_spiral.html#probe_setopts/3"},{"type":"function","title":"exometer_spiral.probe_terminate/1","doc":null,"ref":"exometer_spiral.html#probe_terminate/1"},{"type":"function","title":"exometer_spiral.probe_update/2","doc":null,"ref":"exometer_spiral.html#probe_update/2"},{"type":"module","title":"exometer_uniform","doc":null,"ref":"exometer_uniform.html"},{"type":"function","title":"exometer_uniform.behaviour/0","doc":null,"ref":"exometer_uniform.html#behaviour/0"},{"type":"function","title":"exometer_uniform.probe_code_change/3","doc":null,"ref":"exometer_uniform.html#probe_code_change/3"},{"type":"function","title":"exometer_uniform.probe_get_datapoints/1","doc":null,"ref":"exometer_uniform.html#probe_get_datapoints/1"},{"type":"function","title":"exometer_uniform.probe_get_value/2","doc":null,"ref":"exometer_uniform.html#probe_get_value/2"},{"type":"function","title":"exometer_uniform.probe_handle_msg/2","doc":null,"ref":"exometer_uniform.html#probe_handle_msg/2"},{"type":"function","title":"exometer_uniform.probe_init/3","doc":null,"ref":"exometer_uniform.html#probe_init/3"},{"type":"function","title":"exometer_uniform.probe_reset/1","doc":null,"ref":"exometer_uniform.html#probe_reset/1"},{"type":"function","title":"exometer_uniform.probe_sample/1","doc":null,"ref":"exometer_uniform.html#probe_sample/1"},{"type":"function","title":"exometer_uniform.probe_setopts/3","doc":null,"ref":"exometer_uniform.html#probe_setopts/3"},{"type":"function","title":"exometer_uniform.probe_terminate/1","doc":null,"ref":"exometer_uniform.html#probe_terminate/1"},{"type":"function","title":"exometer_uniform.probe_update/2","doc":null,"ref":"exometer_uniform.html#probe_update/2"},{"type":"module","title":"exometer_util","doc":"Exometer utility functions.","ref":"exometer_util.html"},{"type":"function","title":"exometer_util.clear_event_flag/2","doc":null,"ref":"exometer_util.html#clear_event_flag/2"},{"type":"function","title":"exometer_util.drop_duplicates/1","doc":"drop_duplicates/1 will drop all duplicate elements from a list of tuples identified by their first element. Elements which are not tuples will be dropped as well. If called with a non-list argument, the argument is returned as is.","ref":"exometer_util.html#drop_duplicates/1"},{"type":"function","title":"exometer_util.ensure_all_started/1","doc":null,"ref":"exometer_util.html#ensure_all_started/1"},{"type":"function","title":"exometer_util.get_datapoints/1","doc":null,"ref":"exometer_util.html#get_datapoints/1"},{"type":"function","title":"exometer_util.get_env/2","doc":null,"ref":"exometer_util.html#get_env/2"},{"type":"function","title":"exometer_util.get_opt/2","doc":null,"ref":"exometer_util.html#get_opt/2"},{"type":"function","title":"exometer_util.get_opt/3","doc":null,"ref":"exometer_util.html#get_opt/3"},{"type":"function","title":"exometer_util.get_statistics2/4","doc":null,"ref":"exometer_util.html#get_statistics2/4"},{"type":"function","title":"exometer_util.get_statistics/1","doc":null,"ref":"exometer_util.html#get_statistics/1"},{"type":"function","title":"exometer_util.get_statistics/3","doc":"Calculate statistics from a sorted list of values. This function assumes that you have already sorted the list, and now the number and sum of the elements in the list. The stats calculated are min, max, mean, median and the 50th, 75th, 90th, 95th, 99th, and 99.9th percentiles (note that the 99.9th percentile is labeled 999). This function is similar to bear:get_statistics_subset/2 . mean refers to the arithmetic mean. Fulpatchad med min/max av Magnus Feuer.","ref":"exometer_util.html#get_statistics/3"},{"type":"function","title":"exometer_util.get_status/1","doc":null,"ref":"exometer_util.html#get_status/1"},{"type":"function","title":"exometer_util.histogram/1","doc":null,"ref":"exometer_util.html#histogram/1"},{"type":"function","title":"exometer_util.histogram/2","doc":null,"ref":"exometer_util.html#histogram/2"},{"type":"function","title":"exometer_util.perc/2","doc":null,"ref":"exometer_util.html#perc/2"},{"type":"function","title":"exometer_util.pick_items/2","doc":"Pick values from specified positions in a sorted list of numbers. This function is used to extract datapoints (usually percentiles) from a sorted list of values. Items is a list of {Datapoint, Position} entries.","ref":"exometer_util.html#pick_items/2"},{"type":"function","title":"exometer_util.report_type/3","doc":null,"ref":"exometer_util.html#report_type/3"},{"type":"function","title":"exometer_util.seed0/0","doc":null,"ref":"exometer_util.html#seed0/0"},{"type":"function","title":"exometer_util.seed/0","doc":null,"ref":"exometer_util.html#seed/0"},{"type":"function","title":"exometer_util.seed/1","doc":null,"ref":"exometer_util.html#seed/1"},{"type":"function","title":"exometer_util.set_call_count/2","doc":null,"ref":"exometer_util.html#set_call_count/2"},{"type":"function","title":"exometer_util.set_call_count/3","doc":null,"ref":"exometer_util.html#set_call_count/3"},{"type":"function","title":"exometer_util.set_event_flag/2","doc":null,"ref":"exometer_util.html#set_event_flag/2"},{"type":"function","title":"exometer_util.set_status/2","doc":null,"ref":"exometer_util.html#set_status/2"},{"type":"function","title":"exometer_util.table/0","doc":null,"ref":"exometer_util.html#table/0"},{"type":"function","title":"exometer_util.tables/0","doc":null,"ref":"exometer_util.html#tables/0"},{"type":"function","title":"exometer_util.test_event_flag/2","doc":null,"ref":"exometer_util.html#test_event_flag/2"},{"type":"function","title":"exometer_util.timestamp/0","doc":"Generate a millisecond-resolution timestamp. This timestamp format is used e.g. by the exometer_slide and exometer_histogram implementations.","ref":"exometer_util.html#timestamp/0"},{"type":"function","title":"exometer_util.timestamp_to_datetime/1","doc":"Convert timestamp to a regular datetime. The timestamp is expected","ref":"exometer_util.html#timestamp_to_datetime/1"},{"type":"function","title":"exometer_util.uniform/0","doc":null,"ref":"exometer_util.html#uniform/0"},{"type":"function","title":"exometer_util.uniform/1","doc":null,"ref":"exometer_util.html#uniform/1"},{"type":"type","title":"exometer_util.timestamp/0","doc":null,"ref":"exometer_util.html#t:timestamp/0"},{"type":"extras","title":"Exometer Core - Erlang instrumentation package, core services","doc":"# Exometer Core - Erlang instrumentation package, core services #\n\nCopyright (c) 2014 Basho Technologies, Inc.  All Rights Reserved.\n\n__Version:__ Feb 17 2024 15:18:00\n\n__Authors:__ Ulf Wiger ([`ulf.wiger@feuerlabs.com`](mailto:ulf.wiger@feuerlabs.com)), Magnus Feuer ([`magnus.feuer@feuerlabs.com`](mailto:magnus.feuer@feuerlabs.com)).\n\n[![Build Status](https://github.com/Feuerlabs/exometer_core/actions/workflows/main.yml/badge.svg)](https://github.com/Feuerlabs/exometer_core/actions/workflows/main.yml)\n[![Hex.pm Version][hex version badge]][hex]\n[![Hex.pm License][hex license badge]][hex]\n[![Build Tool][build tool]][hex]\n\nThe Exometer Core package allows for easy and efficient instrumentation of\nErlang code, allowing crucial data on system performance to be\nexported to a wide variety of monitoring systems.\n\nExometer Core comes with a set of pre-defined monitor components, and can\nbe expanded with custom components to handle new types of Metrics, as\nwell as integration with additional external systems such as\ndatabases, load balancers, etc.\n\nThis document gives a high level overview of the Exometer system. For\ndetails, please see the documentation for individual modules, starting\nwith `exometer`.\n\nNote the section on [Dependency Management](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Dependency_Management) for how to deal with\noptional packages, both users and developers.\n\n\n###  Table of Content  ###\n\n1. [Concept and definitions](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Concept_and_definitions)\n    1. [Metric](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Metric)\n    2. [Data Point](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Data_Point)\n    3. [Metric Type](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Metric_Type)\n    4. [Entry Callback](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Entry_Callback)\n    5. [Probe](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Probe)\n    6. [Caching](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Caching)\n    7. [Subscriptions and Reporters](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Subscriptions_and_Reporters)\n2. [Built-in entries and probes](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Built-in_entries_and_probes)\n    1. [counter (exometer native)](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#counter_(exometer_native))\n    2. [fast_counter (exometer native)](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#fast_counter_(exometer_native))\n    3. [gauge (exometer native)](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#gauge_(exometer_native))\n    4. [exometer_histogram (probe)](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#exometer_histogram_(probe))\n    5. [exometer_uniform (probe)](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#exometer_uniform_(probe))\n    6. [exometer_spiral (probe)](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#exometer_spiral_(probe))\n    7. [exometer_function [entry]](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#exometer_function_[entry])\n3. [Built in Reporters](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Built_in_Reporters)\n    1. [exometer_report_tty](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#exometer_report_tty)\n4. [Instrumenting Erlang code](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Instrumenting_Erlang_code)\n    1. [Exometer Core Start](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Exometer_Core_Start)\n    2. [Creating metrics](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Creating_metrics)\n    3. [Deleting metrics](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Deleting_metrics)\n    4. [Setting metric values](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Setting_metric_values)\n    5. [Retrieving metric values](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Retrieving_metric_values)\n    6. [Setting up subscriptions](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Setting_up_subscriptions)\n    7. [Set metric options](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Set_metric_options)\n5. [Configuring Exometer Core](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_Exometer_Core)\n    1. [Configuring type - entry maps](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_type_-_entry_maps)\n    2. [Configuring statically defined entries](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_statically_defined_entries)\n    3. [Configuring static subscriptions](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_static_subscriptions)\n    4. [Configuring reporter plugins](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_reporter_plugins)\n6. [Creating custom exometer entries](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Creating_custom_exometer_entries)\n7. [Creating custom probes](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Creating_custom_probes)\n8. [Creating custom reporter plugins](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Creating_custom_reporter_plugins)\n9. [Dependency management](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Dependency_management)\n\n\n###  Concepts and Definitions  ###\n\nExometer Core introduces a number of concepts and definitions used\nthroughout the documentation and the code.\n\n![Overview](/doc/exometer_overview.png?raw=true)\n\n\n####  Metric  ####\n\nA metric is a specific measurement sampled inside an Erlang system and\nthen reported to the Exometer Core system. An example metric would be\n\"transactions_per_second\", or \"memory_usage\".\n\nMetrics are identified by a list of terms, such as given below:\n\n`[ xml_front_end, parser, file_size ]`\n\nA metric is created through a call by the code to be instrumented to\n`exometer:new/2`. Once created, the metric can be updated through\n`exometer:update/2`, or on its own initiative through the\n`exometer_probe:sample` behavior implementation.\n\n\n####  Data Point  ####\n\nEach metric can consist of multiple data points, where each point has\na specific value.\n\nA typical example of data points would be a\n`transactions_per_second` (tps) metric, usually stored as a\nhistogram covering the last couple of minutes of tps samples. Such a\nhistogram would host multiple values, such as `min`, `max`,\n`median`, `mean`, `50_percentile`, `75_percentile`,\netc.\n\nIt is up to the type of the metric, and the data probe backing that\ntype (see below), to specify which data points are available under the\ngiven metric.\n\n\n####  Metric Type  ####\n\nThe type of a metric, specified when the metric is created through\n`exometer:new/2`, determines which `exometer_entry`\ncallback to use.\n\nThe link between the type and the entry to use is configured\nthrough the `exometer_admin` module, and its associated exometer\ndefaults configuration data.\n\nThe metric type, in other words, is only used to map a metric to a\nconfigurable `exometer_entry` callback.\n\n\n####  Entry Callback  ####\n\nAn exometer entry callback will receive values reported to a metric through the\n`exometer:update/2` call and compile it into one or more data points.\nThe entry callback can either be a counter (implemented natively\nin `exometer`), or a more complex statistical analysis such\nas a uniform distribution or a regular histogram.\n\nThe various outputs from these entries are reported as data points\nunder the given metric.\n\n\n####  Probe  ####\n\nProbes are a further specialization of exometer entries that run in\ntheir own Erlang processes and have their own state (like a\ngen_server). A probe is implemented through the `exometer_probe`\nbehavior.\n\nA probe can be used if independent monitoring is needed of,\nfor example, `/proc` trees, network interfaces, and other subsystems\nthat need periodic sampling. In these cases, the\n`exometer_probe:probe_sample()` call is invoked regularly by exometer,\nin the probe's own process, in order to extract data from\nthe given subsystem and add it to the metric's data points.\n\n\n####  Caching  ####\n\nMetric and data point values are read with the `exometer:get_value/1`\nfunction. In the case of counters, this operation is very fast. With probes,\nthe call results in a synchronous dialog with the probe process, and the\ncost of serving the request depends on the probe implementation and the\nnature of the metric being served.\n\nIf the cost of reading the value is so high that calling the function often\nwould result in prohibitive load, it is possible to cache the value. This is\ndone either explicitly from the probe itself (by calling\n`exometer_cache:write/3`), or by specifying the option `{cache, Lifetime}`\nfor the entry. If an entry has a non-zero cache lifetime specified, the\n`get_value/1` call will try fetching the cached value before calling the\nactual entry and automatically caching the result.\n\nNote that if `{cache, Lifetime}` is not specified, `exometer:get_value/1`\nwill neither read nor write to the cache. It is possible for the probe\nto periodically cache a value regardless of how the cache lifetime is set,\nand the probe may also explicitly read from the cache if it isn't done\nautomatically.\n\n\n####  Subscriptions and Reporters  ####\n\nThe subscription concept, managed by `exometer_report` allows metrics\nand their data points to be sampled at given intervals and delivered\nto one or more recipients, which can be either an arbitrary process\nor a Reporter plugin.\n\nEach subscription ties a specific metric-datapoint pair to a reporter\nand an interval (given in milliseconds). The reporter system will, at\nthe given interval, send the current value of the data point to the\nsubscribing reporter. The subscription, with all its parameters,\nis setup through a call to `exometer_report:subscribe/4`.\n\nIn the case of processes, subscribed-to values will be delivered as a\nmessage. Modules, which implement the `exometer_report` callback\nbehavior, will receive the plugins as a callbacks within the\n`exometer_report` process.\n\nSubscriptions can either be setup at runtime, through\n`exometer_report:subscribe/4` calls, or statically through the\n`exometer_report` configuration data.\n\n\n###  Built-in entries and probes  ###\n\nThere are a number of built-in entries and probes shipped\nwith the Exometer Core package, as described below:\n\n\n####  counter (exometer native)  ####\n\nThe counter is implemented directly in `exometer` to provide simple\ncounters.  A call to `exometer:update/2` will add the provided value\nto the counter.\n\nThe counter can be reset to zero through `exometer:reset/1`.\n\nThe available data points under a metric using the counter entry\nare `value` and `ms_since_reset`.\n\n\n####  fast_counter (exometer native)  ####\n\nA fast counter implements the counter functionality, through the\n`trace_info` system, yielding a speed increase of about 3.5 in\ncomparison to the regular counter.\n\nThe tradeoff is that running tracing and/or debugging may interfere\nwith the counter functionality.\n\nA call to `exometer:update/2` will add the provided value to the\ncounter.\n\nThe counter can be reset to zero through `exometer:reset/1`.\n\nThe available data points under a metric using the fast_counter\nentry are `value` and `ms_since_reset`.\n\n\n####  gauge (exometer native)  ####\n\nThe gauge is implemented directly in `exometer` to provide simple\ngauges.  A call to `exometer:update/2` will set the gauge's value\nto the provided value. That is, the value of the gauge entry is\nalways the most recently provided value.\n\nThe gauge can be reset to zero through `exometer:reset/1`.\n\nThe available data points under a metric using the gauge entry\nare `value` and `ms_since_reset`.\n\n\n####  exometer_histogram (probe)  ####\n\nThe histogram probe stores a given number of updates, provided through\n`exometer:update/2`, in a histogram. The histogram maintains a log\nderived from all values received during a configurable time span and\nprovides min, max, median, mean, and percentile analysis data points\nfor the stored data.\n\nIn order to save memory, the histogram is divided into equal-sized\ntime slots, where each slot spans a settable interval. All values\nreceived during a time slot will be averaged into a single value to be\nstored in the histogram once the time slot expires. The averaging\nfunction (which can be replaced by the caller), allows for\nhigh-frequency update metrics to have their resolution traded against\nresource consumption.\n\n\n####  exometer_uniform (probe)  ####\n\nThe uniform probe provides a uniform sample over a pool of values\nprovided through `exometer:update/2`. When the pool reaches its configurable\nmax size, existing values will be replaced at random to make space for\nnew values. Much like `exometer_histogram`, the uniform probe\nprovides min, max, median, mean, and percentile analysis data points\nfor the stored data.\n\n\n####  exometer_spiral (probe)  ####\n\nThe spiral probe maintains the total sum of all values stored in its\nhistogram. The histogram has a configurable time span, all values\nprovided to the probe, through `exometer:update/2`, within that time\nspan will be summed up and reported. If, for example, the histogram\ncovers 60 seconds, the spiral probe will report the sum of all\nvalues reported during the last minute.\n\nThe grand total of all values received during the lifetime of the\nprobe is also available.\n\n\n####  exometer_function [entry]  ####\n\nThe function entry allows for a simple caller-supplied function to be\ninvoked in order to retrieve non-exometer data. The\n`exometer_function:get_value/4` function will invoke a\n`Module:Function(DataPoints)` call, where `Module` and\n`Function` are provided by the caller.\n\nThe function entry provides an easy way of integrating an external\nsystem without having to write a complete entry.\n\n\n###  Built in Reporters  ###\n\nExometer Core ships with some built-in reporters which can be used to forward\nupdated metrics and their data points to external systems. They can also\nserve as templates for custom-developed reporters.\n\n\n####  exometer_report_tty  ####\n\nThe `exometer_report_tty` reporter is mainly intended for experimentation.\nIt outputs reports directly to the tty.\n\n\n###  Instrumenting Erlang code  ###\n\nThe code using Exometer Core needs to be instrumented in order to setup and\nuse metrics reporting.\n\n\n####  Exometer Core Start  ####\n\nThe system using Exometer Core must start the `exometer` application\nprior to using it:\n\n```erlang\n\napplication:start(lager),\napplication:start(exometer_core).\n```\n\nNote that dependent applications need to be started first. On newer OTP versions\n(R61B or later), you can use `application:ensure_all_started(exometer)`.\n\nFor testing, you can also use [`exometer:start/0`](https://github.com/Feuerlabs/exometer_core/blob/master/doc/exometer.md#start-0).\n\nSee [Configuring Exometer Core](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_Exometer_Core) for details on configuration data\nformat.\n\n\n####  Creating metrics  ####\n\nA metric, can be created throuh a call to\n\n```erlang\n\nexometer:new(Name, Type)\n```\n\n`Name` is a list of atoms, uniquely identifying the metric created.\nThe type of the metric, specified by `Type` will be mapped\nto an exometer entry through the table maintained by\n`exometer_admin` Please see the [Configuring type - entry\nmaps](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_type_-_entry_maps) for details.\n\nThe resolved entry to use will determine the data points available\nunder the given metric.\n\n\n####  Deleting metrics  ####\n\nA metric previously created with `exometer:new/2` can be deleted by\n`exometer:delete/1`.\n\nAll subscriptions to the deleted metrics will be cancelled.\n\n\n####  Setting metric values  ####\n\nA created metric can have its value updated through the\n`exometer:update/2` function:\n\n```erlang\n\nexometer:update(Name, Value)\n```\n\nThe `Name` parameter is the same atom list provided to a previous\n`exometer:new/2` call. The `Value` is an arbitrarty element that is\nforwarded to the `exometer:update/2` function of the entry/probe that the\nmetric is mapped to.\n\nThe receiving entry/probe will process the provided value and modify\nits data points accordingly.\n\n\n####  Retrieving metric values  ####\n\nExometer-using code can at any time retrieve the data point values\nassociated with a previously created metric. In order to find out which\ndata points are available for a metric, the following call can be used:\n\n```erlang\n\nexometer:info(Name, datapoints)\n```\n\nThe `Name` parameter is the same atom list provided to a previous\n`exometer:new/2` call. The call will return a list of data point\natoms that can then be provided to `exometer:get_value/1` to\nretrieve their actual value:\n\n```erlang\n\nexometer:get_value(Name, DataPoint)\n```\n\nThe `Name` paramer identifies the metric, and `DataPoints`\nidentifies the data points (returned from the previous `info()` call)\nto retrieve the value for.\n\nIf no DataPoints are provided, the values of a default list of data points,\ndetermined by the backing entry / probe, will be returned.\n\n\n####  Setting up subscriptions  ####\n\nA subscription can either be statically configured, or dynamically\nsetup from within the code using Exometer Core. For details on statically\nconfigured subscriptions, please see [Configuring static subscriptions](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_static_subscriptions).\n\nA dynamic subscription can be setup with the following call:\n\n```erlang\n\nexometer_report:subscribe(Recipient, Metric, DataPoint, Inteval)\n```\n\n`Recipient` is the name of a reporter.\n\n\n####  Set metric options  ####\n\nEach created metric can have options setup for it through the following call:\n\n```erlang\n\nexometer:setopts(Name, Options)\n```\n\nThe `Name` paramer identifies the metric to set the options for, and\nOptions is a proplist (`[{ Key, Value },...]`) with the options to be\nset.\n\nExometer Core looks up the the backing entry that hosts the metric with\nthe given Name, and will invoke the entry\\'s `setopts/4` function to set\nthe actual options. Please see the `setopts/4` function for the various\nentries for details.\n\n\n###  Configuring Exometer Core  ###\n\nExometer Core defaults can be changed either through OTP application environment\nvariables or through the use of Basho's `cuttlefish`\n([`https://github.com/basho/cuttlefish`](https://github.com/basho/cuttlefish)).\n\n__Note:__ Exometer Core will check both the `exometer` and the `exometer_core`\napplication environments. The `exometer` environment overrides the\n`exometer_core` environment. However, if only `exometer_core` is used, any\n`exometer` environment will simply be ignored. This is because of the\napplication controller: environment data is not loaded until the application\nin question is loaded.\n\n\n####  Configuring type - entry maps  ####\n\nThe dynamic method of configuring defaults for `exometer` entries is:\n\n```erlang\n\nexometer_admin:set_default(NamePattern, Type, Default)\n```\n\nWhere `NamePattern` is a list of terms describing what is essentially\na name prefix with optional wildcards (`'_'`). A pattern that\nmatches any legal name is `['_']`.\n\n`Type` is an atom defining a type of metric. The types already known to\n`exometer`, `counter`, `fast_counter`, `ticker`, `uniform`, `histogram`,\n`spiral`, `netlink`, and `probe` may be redefined, but other types can be\ndescribed as well.\n\n`Default` is either an `#exometer_entry{}` record (unlikely), or a list of\n`{Key, Value}` options, where the keys correspond to `#exometer_entry` record\nattribute names. The following attributes make sense to preset:\n\n```erlang\n\n{module, atom()}              % the callback module\n{status, enabled | disabled}  % operational status of the entry\n{cache, non_neg_integer()}    % cache lifetime (ms)\n{options, [{atom(), any()}]}  % entry-specific options\n```\n\nBelow is an example, from `exometer_core/priv/app.config`:\n\n```erlang\n\n{exometer, [\n    {defaults, [\n        {['_'], function , [{module, exometer_function}]},\n        {['_'], counter  , [{module, exometer}]},\n        {['_'], histogram, [{module, exometer_histogram}]},\n        {['_'], spiral   , [{module, exometer_spiral}]}\n    ]}\n]}\n```\n\nIn systems that use CuttleFish, the file `exometer/priv/exometer.schema`\ncontains a schema for default settings. The setup corresponding to the above\ndefaults would be as follows:\n\n```ini\n\nexometer.template.function.module  = exometer_function\nexometer.template.counter.module   = exometer\nexometer.template.histogram.module = exometer_histogram\nexometer.template.spiral.module    = exometer_spiral\n```\n\n\n####  Configuring statically defined entries  ####\n\nUsing the `exometer` environment variable `predefined`, entries can be added\nat application startup. The variable should have one of the following values:\n\n* `{script, File}` - `File` will be processed using `file:script/2`. The return\n  value (the result of the last expression in the script) should be a list of`{Name, Type, Options}` tuples.\n\n* `{apply, M, F, A}` - The result of `apply(M, F, A)` should be `{ok, L}` where`L` is a list of `{Name, Type, Options}` tuples.\n\n* `L`, where L is a list of `{Name, Type, Options}` tuples or extended\ninstructions (see below).\n\nThe list of instructions may include:\n\n* `{delete, Name}` - deletes `Name` from the exometer registry.\n\n* `{select_delete, Pattern}` - applies a select pattern and\ndeletes all matching entries.\n\n* `{re_register, {Name, Type, Options}}` - redefines an entry if present,\notherwise creates it.\n\nExometer Core will also scan all loaded applications for the environment\nvariables `exometer_defaults` and `exometer_predefined`, and process\nas above. If an application is loaded and started after exometer has started,\nit may call the function `exometer:register_application()` or\n`exometer:register_application(App)`. This function will do nothing if\nexometer isn't already running, and otherwise process the `exometer_defaults`\nand `exometer_predefined` variables as above. The function can also be\ncalled during upgrade, as it will re-apply the settings each time.\n\n\n####  Configuring static subscriptions  ####\n\nStatic subscriptions, which are automatically setup at exometer\nstartup without having to invoke `exometer_report:subscribe/4`, are\nconfigured through the report sub section under exometer.\n\nBelow is an example, from `exometer/priv/app.config`:\n\n```erlang\n\n{exometer, [\n    {report, [\n        {subscribers, [\n            {exometer_report_collectd, [db, cache, hits], mean, 2000, true},\n            {exometer_report_collectd, [db, cache, hits], max, 5000, false}\n        ]}\n    ]}\n]}\n```\n\nThe `report` section configures static subscriptions and reporter\nplugins. See [Configuring reporter plugins](https://github.com/Feuerlabs/exometer_core/blob/master/doc/README.md#Configuring_reporter_plugins) for details on\nhow to configure individual plugins.\n\nThe `subscribers` sub-section contains all static subscriptions to be\nsetup att exometer applications start. Each tuple in the prop list\nshould be of one of the following formats:\n\n* `{Reporter, Metric, DataPoint, Interval}`\n\n* `{Reporter, Metric, DataPoint, Interval, RetryFailedMetrics}`\n\n* `{Reporter, Metric, DataPoint, Interval, RetryFailedMetrics, Extra}`\n\n* `{apply, {M, F, A}}`\n\n* `{select, {MatchPattern, DataPoint, Interval [, Retry [, Extra] ]}}`\n\nIn the case of `{apply, M, F, A}`, the result of `apply(M, F, A)` must\nbe a list of `subscribers` tuples.\n\nIn the case of `{select, Expr}`, a list of metrics is fetched using\n`exometer:select(MatchPattern)`, where the result must be on the form\n`{Key, Type, Status}` (i.e. what corresponds to `'$_'`).\nThe rest of the items will be applied to each of the matching entries.\n\nThe meaning of the above tuple elements is:\n\n+ `Reporter :: module()` Specifies the reporter plugin module, such as`exometer_report_collectd` that is to receive updated metric's data\npoints.\n\n+ `Metric :: [atoms()]` Specifies the path to a metric previously created with an`exometer:new/2` call.\n\n+ `DataPoint` ::  atom() | [atom()]' Specifies the data point within the given metric to send to the\n    receiver. The data point must match one of the data points returned by`exometer:info(Name, datapoints)` for the given metrics name.\n\n+ `Interval` :: integer()' (milliseconds) Specifies the interval, in milliseconds, between each update of the\ngiven metric's data point. At the given interval, the data point will\nbe samples, and the result will be sent to the receiver.\n\n+ `RetryFailedMetrics :: boolean()` Specifies if the metric should be continued to be reported\n    even if it is not found during a reporting cycle. This would be\n    the case if a metric is not created by the time it is reported for\n    the first time. If the metric will be created at a later time,\n    this value should be set to true. Set this value to false if all\n    attempts to report the metric should stop if when is not found.\n    The default value is `true`.\n\n+ `Extra :: any()` Provides a means to pass along extra information for a given\n   subscription. An example is the `syntax` option for the SNMP reporter,\n   in which case `Extra` needs to be a property list.\n\nExample configuration in sys.config, using the `{select, Expr}` pattern:\n\n```erlang\n\n[\n {exometer, [\n             {predefined,\n              [{[a,1], counter, []},\n               {[a,2], counter, []},\n               {[b,1], counter, []},\n               {[c,1], counter, []}]},\n             {report,\n              [\n               {reporters,\n                [{exometer_report_tty, []}]},\n               {subscribers,\n                [{select, {[{ {[a,'_'],'_','_'}, [], ['$_']}],\n                           exometer_report_tty, value, 1000}}]}\n              ]}\n            ]}\n].\n\n```\n\nThis will activate a subscription on `[a,1]` and `[a,2]` in the\n`exometer_report_tty` reporter, firing once per second.\n\n\n####  Configuring reporter plugins  ####\n\nThe various reporter plugins to be loaded by exometer are configured\nin the `report` section under `reporters`\n\nEach reporter has an entry named after its module, and the content of\nthat entry is dependent on the reporter itself. The following chapters\nspecifies the configuration parameters for the reporters shipped with\nexometer.\n\n\n###  Creating custom exometer entries  ###\n\nPlease see @see exometer_entry documentation for details.\n\n\n###  Creating custom probes  ###\n\nPlease see @see exometer_probe documentation for details.\n\n\n###  Creating custom reporter plugins  ###\n\nPlease see @see exometer_report documentation for details.\n\n\n####  Customizing rebar.config  ####\n\nThe OS environment variables `EXOMETER_CORE_CONFIG_PREPROCESS` and\n`EXOMETER_CORE_CONFIG_POSTPROCESS` can be used to insert a script, similar to\n`rebar.config.script` in the processing flow of the exometer build.\n\nAs the names imply, the script given by `EXOMETER_CONFIG_CONFIG_PREPROCESS`\n(if any) will be run before exometer does any processing of its own, and the\n`EXOMETER_CORE_CONFIG_POSTPROCESS` script (if any) will be run after all other\nprocessing is complete.\n\n[travis]: https://travis-ci.org/Feuerlabs/exometer_core\n[travis badge]: https://img.shields.io/travis/Feuerlabs/exometer_core/master.svg?style=flat-square\n[hex]: https://hex.pm/packages/exometer_core\n[hex version badge]: https://img.shields.io/hexpm/v/exometer_core.svg?style=flat-square\n[hex license badge]: https://img.shields.io/hexpm/l/exometer_core.svg?style=flat-square\n[erlang version badge]: https://img.shields.io/badge/erlang-18--21-blue.svg?style=flat-square\n[build tool]: https://img.shields.io/badge/build%20tool-rebar3-orange.svg?style=flat-square","ref":"readme.html"},{"type":"extras","title":"Modules ## - Exometer Core - Erlang instrumentation package, core services","doc":"exometer   \n   exometer_admin   \n   exometer_alias   \n   exometer_cache   \n   exometer_cpu   \n   exometer_duration   \n   exometer_entry   \n   exometer_function   \n   exometer_histogram   \n   exometer_info   \n   exometer_probe   \n   exometer_proc   \n   exometer_report   \n   exometer_report_logger   \n   exometer_report_tty   \n   exometer_shallowtree   \n   exometer_slide   \n   exometer_slot_slide   \n   exometer_spiral   \n   exometer_uniform   \n   exometer_util","ref":"readme.html#modules"},{"type":"extras","title":"LICENSE","doc":"Mozilla Public License, version 2.0\n\n1. Definitions\n\n1.1. \"Contributor\"\n\n     means each individual or legal entity that creates, contributes to the\n     creation of, or owns Covered Software.\n\n1.2. \"Contributor Version\"\n\n     means the combination of the Contributions of others (if any) used by a\n     Contributor and that particular Contributor's Contribution.\n\n1.3. \"Contribution\"\n\n     means Covered Software of a particular Contributor.\n\n1.4. \"Covered Software\"\n\n     means Source Code Form to which the initial Contributor has attached the\n     notice in Exhibit A, the Executable Form of such Source Code Form, and\n     Modifications of such Source Code Form, in each case including portions\n     thereof.\n\n1.5. \"Incompatible With Secondary Licenses\"\n     means\n\n     a. that the initial Contributor has attached the notice described in\n        Exhibit B to the Covered Software; or\n\n     b. that the Covered Software was made available under the terms of\n        version 1.1 or earlier of the License, but not also under the terms of\n        a Secondary License.\n\n1.6. \"Executable Form\"\n\n     means any form of the work other than Source Code Form.\n\n1.7. \"Larger Work\"\n\n     means a work that combines Covered Software with other material, in a\n     separate file or files, that is not Covered Software.\n\n1.8. \"License\"\n\n     means this document.\n\n1.9. \"Licensable\"\n\n     means having the right to grant, to the maximum extent possible, whether\n     at the time of the initial grant or subsequently, any and all of the\n     rights conveyed by this License.\n\n1.10. \"Modifications\"\n\n     means any of the following:\n\n     a. any file in Source Code Form that results from an addition to,\n        deletion from, or modification of the contents of Covered Software; or\n\n     b. any new file in Source Code Form that contains any Covered Software.\n\n1.11. \"Patent Claims\" of a Contributor\n\n      means any patent claim(s), including without limitation, method,\n      process, and apparatus claims, in any patent Licensable by such\n      Contributor that would be infringed, but for the grant of the License,\n      by the making, using, selling, offering for sale, having made, import,\n      or transfer of either its Contributions or its Contributor Version.\n\n1.12. \"Secondary License\"\n\n      means either the GNU General Public License, Version 2.0, the GNU Lesser\n      General Public License, Version 2.1, the GNU Affero General Public\n      License, Version 3.0, or any later versions of those licenses.\n\n1.13. \"Source Code Form\"\n\n      means the form of the work preferred for making modifications.\n\n1.14. \"You\" (or \"Your\")\n\n      means an individual or a legal entity exercising rights under this\n      License. For legal entities, \"You\" includes any entity that controls, is\n      controlled by, or is under common control with You. For purposes of this\n      definition, \"control\" means (a) the power, direct or indirect, to cause\n      the direction or management of such entity, whether by contract or\n      otherwise, or (b) ownership of more than fifty percent (50%) of the\n      outstanding shares or beneficial ownership of such entity.\n\n\n2. License Grants and Conditions\n\n2.1. Grants\n\n     Each Contributor hereby grants You a world-wide, royalty-free,\n     non-exclusive license:\n\n     a. under intellectual property rights (other than patent or trademark)\n        Licensable by such Contributor to use, reproduce, make available,\n        modify, display, perform, distribute, and otherwise exploit its\n        Contributions, either on an unmodified basis, with Modifications, or\n        as part of a Larger Work; and\n\n     b. under Patent Claims of such Contributor to make, use, sell, offer for\n        sale, have made, import, and otherwise transfer either its\n        Contributions or its Contributor Version.\n\n2.2. Effective Date\n\n     The licenses granted in Section 2.1 with respect to any Contribution\n     become effective for each Contribution on the date the Contributor first\n     distributes such Contribution.\n\n2.3. Limitations on Grant Scope\n\n     The licenses granted in this Section 2 are the only rights granted under\n     this License. No additional rights or licenses will be implied from the\n     distribution or licensing of Covered Software under this License.\n     Notwithstanding Section 2.1(b) above, no patent license is granted by a\n     Contributor:\n\n     a. for any code that a Contributor has removed from Covered Software; or\n\n     b. for infringements caused by: (i) Your and any other third party's\n        modifications of Covered Software, or (ii) the combination of its\n        Contributions with other software (except as part of its Contributor\n        Version); or\n\n     c. under Patent Claims infringed by Covered Software in the absence of\n        its Contributions.\n\n     This License does not grant any rights in the trademarks, service marks,\n     or logos of any Contributor (except as may be necessary to comply with\n     the notice requirements in Section 3.4).\n\n2.4. Subsequent Licenses\n\n     No Contributor makes additional grants as a result of Your choice to\n     distribute the Covered Software under a subsequent version of this\n     License (see Section 10.2) or under the terms of a Secondary License (if\n     permitted under the terms of Section 3.3).\n\n2.5. Representation\n\n     Each Contributor represents that the Contributor believes its\n     Contributions are its original creation(s) or it has sufficient rights to\n     grant the rights to its Contributions conveyed by this License.\n\n2.6. Fair Use\n\n     This License is not intended to limit any rights You have under\n     applicable copyright doctrines of fair use, fair dealing, or other\n     equivalents.\n\n2.7. Conditions\n\n     Sections 3.1, 3.2, 3.3, and 3.4 are conditions of the licenses granted in\n     Section 2.1.\n\n\n3. Responsibilities\n\n3.1. Distribution of Source Form\n\n     All distribution of Covered Software in Source Code Form, including any\n     Modifications that You create or to which You contribute, must be under\n     the terms of this License. You must inform recipients that the Source\n     Code Form of the Covered Software is governed by the terms of this\n     License, and how they can obtain a copy of this License. You may not\n     attempt to alter or restrict the recipients' rights in the Source Code\n     Form.\n\n3.2. Distribution of Executable Form\n\n     If You distribute Covered Software in Executable Form then:\n\n     a. such Covered Software must also be made available in Source Code Form,\n        as described in Section 3.1, and You must inform recipients of the\n        Executable Form how they can obtain a copy of such Source Code Form by\n        reasonable means in a timely manner, at a charge no more than the cost\n        of distribution to the recipient; and\n\n     b. You may distribute such Executable Form under the terms of this\n        License, or sublicense it under different terms, provided that the\n        license for the Executable Form does not attempt to limit or alter the\n        recipients' rights in the Source Code Form under this License.\n\n3.3. Distribution of a Larger Work\n\n     You may create and distribute a Larger Work under terms of Your choice,\n     provided that You also comply with the requirements of this License for\n     the Covered Software. If the Larger Work is a combination of Covered\n     Software with a work governed by one or more Secondary Licenses, and the\n     Covered Software is not Incompatible With Secondary Licenses, this\n     License permits You to additionally distribute such Covered Software\n     under the terms of such Secondary License(s), so that the recipient of\n     the Larger Work may, at their option, further distribute the Covered\n     Software under the terms of either this License or such Secondary\n     License(s).\n\n3.4. Notices\n\n     You may not remove or alter the substance of any license notices\n     (including copyright notices, patent notices, disclaimers of warranty, or\n     limitations of liability) contained within the Source Code Form of the\n     Covered Software, except that You may alter any license notices to the\n     extent required to remedy known factual inaccuracies.\n\n3.5. Application of Additional Terms\n\n     You may choose to offer, and to charge a fee for, warranty, support,\n     indemnity or liability obligations to one or more recipients of Covered\n     Software. However, You may do so only on Your own behalf, and not on\n     behalf of any Contributor. You must make it absolutely clear that any\n     such warranty, support, indemnity, or liability obligation is offered by\n     You alone, and You hereby agree to indemnify every Contributor for any\n     liability incurred by such Contributor as a result of warranty, support,\n     indemnity or liability terms You offer. You may include additional\n     disclaimers of warranty and limitations of liability specific to any\n     jurisdiction.\n\n4. Inability to Comply Due to Statute or Regulation\n\n   If it is impossible for You to comply with any of the terms of this License\n   with respect to some or all of the Covered Software due to statute,\n   judicial order, or regulation then You must: (a) comply with the terms of\n   this License to the maximum extent possible; and (b) describe the\n   limitations and the code they affect. Such description must be placed in a\n   text file included with all distributions of the Covered Software under\n   this License. Except to the extent prohibited by statute or regulation,\n   such description must be sufficiently detailed for a recipient of ordinary\n   skill to be able to understand it.\n\n5. Termination\n\n5.1. The rights granted under this License will terminate automatically if You\n     fail to comply with any of its terms. However, if You become compliant,\n     then the rights granted under this License from a particular Contributor\n     are reinstated (a) provisionally, unless and until such Contributor\n     explicitly and finally terminates Your grants, and (b) on an ongoing\n     basis, if such Contributor fails to notify You of the non-compliance by\n     some reasonable means prior to 60 days after You have come back into\n     compliance. Moreover, Your grants from a particular Contributor are\n     reinstated on an ongoing basis if such Contributor notifies You of the\n     non-compliance by some reasonable means, this is the first time You have\n     received notice of non-compliance with this License from such\n     Contributor, and You become compliant prior to 30 days after Your receipt\n     of the notice.\n\n5.2. If You initiate litigation against any entity by asserting a patent\n     infringement claim (excluding declaratory judgment actions,\n     counter-claims, and cross-claims) alleging that a Contributor Version\n     directly or indirectly infringes any patent, then the rights granted to\n     You by any and all Contributors for the Covered Software under Section\n     2.1 of this License shall terminate.\n\n5.3. In the event of termination under Sections 5.1 or 5.2 above, all end user\n     license agreements (excluding distributors and resellers) which have been\n     validly granted by You or Your distributors under this License prior to\n     termination shall survive termination.\n\n6. Disclaimer of Warranty\n\n   Covered Software is provided under this License on an \"as is\" basis,\n   without warranty of any kind, either expressed, implied, or statutory,\n   including, without limitation, warranties that the Covered Software is free\n   of defects, merchantable, fit for a particular purpose or non-infringing.\n   The entire risk as to the quality and performance of the Covered Software\n   is with You. Should any Covered Software prove defective in any respect,\n   You (not any Contributor) assume the cost of any necessary servicing,\n   repair, or correction. This disclaimer of warranty constitutes an essential\n   part of this License. No use of  any Covered Software is authorized under\n   this License except under this disclaimer.\n\n7. Limitation of Liability\n\n   Under no circumstances and under no legal theory, whether tort (including\n   negligence), contract, or otherwise, shall any Contributor, or anyone who\n   distributes Covered Software as permitted above, be liable to You for any\n   direct, indirect, special, incidental, or consequential damages of any\n   character including, without limitation, damages for lost profits, loss of\n   goodwill, work stoppage, computer failure or malfunction, or any and all\n   other commercial damages or losses, even if such party shall have been\n   informed of the possibility of such damages. This limitation of liability\n   shall not apply to liability for death or personal injury resulting from\n   such party's negligence to the extent applicable law prohibits such\n   limitation. Some jurisdictions do not allow the exclusion or limitation of\n   incidental or consequential damages, so this exclusion and limitation may\n   not apply to You.\n\n8. Litigation\n\n   Any litigation relating to this License may be brought only in the courts\n   of a jurisdiction where the defendant maintains its principal place of\n   business and such litigation shall be governed by laws of that\n   jurisdiction, without reference to its conflict-of-law provisions. Nothing\n   in this Section shall prevent a party's ability to bring cross-claims or\n   counter-claims.\n\n9. Miscellaneous\n\n   This License represents the complete agreement concerning the subject\n   matter hereof. If any provision of this License is held to be\n   unenforceable, such provision shall be reformed only to the extent\n   necessary to make it enforceable. Any law or regulation which provides that\n   the language of a contract shall be construed against the drafter shall not\n   be used to construe this License against a Contributor.\n\n\n10. Versions of the License\n\n10.1. New Versions\n\n      Mozilla Foundation is the license steward. Except as provided in Section\n      10.3, no one other than the license steward has the right to modify or\n      publish new versions of this License. Each version will be given a\n      distinguishing version number.\n\n10.2. Effect of New Versions\n\n      You may distribute the Covered Software under the terms of the version\n      of the License under which You originally received the Covered Software,\n      or under the terms of any subsequent version published by the license\n      steward.\n\n10.3. Modified Versions\n\n      If you create software not governed by this License, and you want to\n      create a new license for such software, you may create and use a\n      modified version of this License if you rename the license and remove\n      any references to the name of the license steward (except to note that\n      such modified license differs from this License).\n\n10.4. Distributing Source Code Form that is Incompatible With Secondary\n      Licenses If You choose to distribute Source Code Form that is\n      Incompatible With Secondary Licenses under the terms of this version of\n      the License, the notice described in Exhibit B of this License must be\n      attached.\n\nExhibit A - Source Code Form License Notice\n\n      This Source Code Form is subject to the\n      terms of the Mozilla Public License, v.\n      2.0. If a copy of the MPL was not\n      distributed with this file, You can\n      obtain one at\n      http://mozilla.org/MPL/2.0/.\n\nIf it is not possible or desirable to put the notice in a particular file,\nthen You may include the notice in a location (such as a LICENSE file in a\nrelevant directory) where a recipient would be likely to look for such a\nnotice.\n\nYou may add additional accurate notices of copyright ownership.\n\nExhibit B - \"Incompatible With Secondary Licenses\" Notice\n\n      This Source Code Form is \"Incompatible\n      With Secondary Licenses\", as defined by\n      the Mozilla Public License, v. 2.0.","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}